import { defineComponent as ye, ref as ge, watch as z, onBeforeUnmount as Ce, openBlock as Le, createBlock as be, unref as Re } from "vue";
import * as M from "@turf/helpers";
import A from "@turf/distance";
import Ee from "@turf/destination";
import { bufferImages as he, BUFFER_LAYER_ADDITIONAL as Ie, bufferTuffOptions as N } from "../../buffer-layer/src/constants.mjs";
import { useBufferLayer as ve } from "../../buffer-layer/src/use-buffer-layer.mjs";
import { handleCloseImage as xe, generateDotImage as G } from "../../buffer-layer/src/utils.mjs";
import { MbImageLoader as Pe } from "../../image-loader/index.mjs";
import { bufferCircleLayerV2Props as _e, bufferCircleLayerV2Emits as ze } from "./buffer-circle-layer-v2.mjs";
import { createBufferCircleLayer as Be } from "../../buffer-circle-layer/src/utils.mjs";
import { usePropsWatcher as Se } from "../../buffer-circle-layer/src/use-buffer-circle.mjs";
import { useMapCreated as Te } from "../../map/src/use-map.mjs";
const De = {
  name: "MbBufferCircleLayerV2"
}, Ve = ye({
  ...De,
  props: _e,
  emits: ze,
  setup(k, { emit: j }) {
    const r = k, y = j, { getVisibility: g } = ve(r), B = "circle-v2-close", _ = ge(
      xe(he(B), r.closeIconUrl)
    );
    let t, b = 0, R = r.radius, u = [], h = [], f, E = !1, m, C = !1, L = !1;
    const { BUFFER_CIRCLE_LAYER: n, BUFFER_CIRCLE_SOURCE: d } = Be(), K = () => {
      _.value.push(
        G(
          "BufferCircleCenterSVG",
          r.centerColor,
          r.centerRadius
        ),
        G(
          "BufferCircleResizerSVG",
          r.resizerColor,
          r.resizerRadius
        )
      );
    }, V = () => {
      Object.keys(n).forEach((e) => {
        t.getLayer(n[e]) && t.setLayoutProperty(
          n[e],
          "visibility",
          g(r[Ie[e]])
        );
      });
    }, c = (e, o, s) => {
      typeof o == "string" ? (t.on(e, o, s), h.push({
        event: e,
        target: o,
        handler: s
      })) : (t.on(e, o), h.push({
        event: e,
        handler: o
      }));
    }, Z = () => {
      h.forEach((e) => {
        e.target ? t.off(
          e.event,
          e.target,
          e.handler
        ) : t.off(e.event, e.handler);
      }), h = [];
    }, q = () => {
      c(
        "mouseenter",
        n.CIRCLE_BACKGROUND,
        S
      ), c(
        "mouseleave",
        n.CIRCLE_BACKGROUND,
        W
      ), c("mousedown", n.CIRCLE_BACKGROUND, Q), c("touchstart", n.CIRCLE_BACKGROUND, X), c("mouseenter", n.RESIZER, Y), c("mouseleave", n.RESIZER, H), c("mousedown", n.RESIZER, $), c("touchstart", n.RESIZER, J), c("click", n.CLOSE_BUTTON, (e) => {
        y("close", e);
      });
    }, S = () => {
      f.style.cursor = "move", E = !0, t.dragPan.disable(), y("mouseenter");
    }, W = () => {
      f.style.cursor = "", E = !1, t.dragPan.enable(), y("mouseleave");
    }, Y = () => {
      f.style.cursor = "nwse-resize", E = !0, t.dragPan.disable(), y("mouseenter");
    }, H = (e) => {
      A(
        [e.lngLat.lng, e.lngLat.lat],
        u
      ) > b ? (f.style.cursor = "", E = !1, t.dragPan.enable(), y("mouseleave")) : S();
    }, $ = (e) => {
      E && (m = e.lngLat, C = !0, L = !1, f.style.cursor = "nwse-resize", c("mousemove", I), t.once("mouseup", T));
    }, J = (e) => {
      e.points.length === 1 && (e.preventDefault(), m = e.lngLat, C = !0, L = !1, c("touchmove", I), t.once("touchend", (o) => {
        T(), t.dragPan.enable();
      }));
    }, Q = (e) => {
      !E || !r.draggable || (m = e.lngLat, L = !0, C = !1, f.style.cursor = "grab", c("mousemove", v), t.once("mouseup", D));
    }, X = (e) => {
      e.points.length !== 1 || !r.draggable || (e.preventDefault(), m = e.lngLat, L = !0, C = !1, c("touchmove", v), t.once("touchend", (o) => {
        D(), t.dragPan.enable();
      }));
    }, I = (e) => {
      if (!C) return;
      f.style.cursor = "nwse-resize";
      const o = e.lngLat.lat - m.lat, s = A(
        M.point([m.lng, m.lat]),
        M.point([e.lngLat.lng, e.lngLat.lat]),
        N
      );
      m = { lng: e.lngLat.lng, lat: e.lngLat.lat }, b += s * (o > 0 ? 1 : -1), R = Math.abs(+b.toFixed(1)), P(u);
    }, T = () => {
      C && (f.style.cursor = "", C = !1, y("update", {
        center: u,
        radius: R
      }), t.off("mousemove", I), t.off("touchmove", I));
    }, v = (e) => {
      if (!L) return;
      f.style.cursor = "grabbing";
      const o = e.lngLat.lng - m.lng, s = e.lngLat.lat - m.lat;
      m = { lng: e.lngLat.lng, lat: e.lngLat.lat }, F([u[0] + o, u[1] + s]);
    }, D = () => {
      L && (f.style.cursor = "", L = !1, t.off(
        "mousemove",
        n.CIRCLE_BACKGROUND,
        v
      ), t.off(
        "touchmove",
        n.CIRCLE_BACKGROUND,
        v
      ), y("update", {
        center: u,
        radius: R
      }));
    }, O = (e) => {
      const o = Ee(e, b, 0), s = t.project(e), a = t.project(
        o.geometry.coordinates
      ), i = Math.sqrt(
        (a.y - s.y) ** 2 + (a.x - s.x) ** 2
      );
      return { center: o, centerPx: s, targetPx: a, radiusPx: i };
    }, ee = (e) => {
      const { centerPx: o, radiusPx: s } = O(e), i = te(
        o.x,
        o.y,
        s,
        360 / N.steps
      ).map((p) => t.unproject(p)), l = [];
      return i.forEach((p) => {
        l.push([p.lng, p.lat]);
      }), l.push([...l[0]]), l;
    }, te = (e, o, s, a) => {
      const i = [];
      let l = 0;
      for (; l < 360; ) {
        const p = x(e, o, s, l);
        i.push(p), l += a;
      }
      return i;
    }, x = (e, o, s, a) => {
      const i = a * (Math.PI / 180), l = e + s * Math.cos(i), p = o + s * Math.sin(i);
      return [l, p];
    }, re = (e) => {
      const { centerPx: o, radiusPx: s } = O(e), a = t.unproject(
        x(o.x, o.y, s, 315)
      ), i = [a.lng, a.lat], l = t.unproject(
        x(o.x, o.y, s, 0)
      ), p = [
        l.lng,
        l.lat
      ], w = t.unproject(
        x(o.x, o.y, s, 225)
      ), le = [w.lng, w.lat], ue = {
        type: "Feature",
        properties: {
          bufferType: "main"
        },
        geometry: {
          type: "Polygon",
          coordinates: [ee(e)]
        }
      }, fe = {
        type: "Feature",
        properties: {
          bufferType: "close"
        },
        geometry: {
          type: "Point",
          coordinates: i
        }
      }, me = {
        type: "Feature",
        properties: {
          bufferType: "resizer"
        },
        geometry: {
          type: "Point",
          coordinates: le
        }
      }, de = {
        type: "Feature",
        properties: {
          bufferType: "center"
        },
        geometry: {
          type: "Point",
          coordinates: e
        }
      }, pe = {
        type: "Feature",
        properties: {
          bufferType: "counter",
          text: r.formatter ? r.formatter(R) : `${R}km`
        },
        geometry: {
          type: "Point",
          coordinates: p
        }
      };
      return {
        circleMain: ue,
        circleCenter: de,
        circleResizer: me,
        closeButton: fe,
        counter: pe
      };
    }, oe = ({
      circleMain: e,
      circleCenter: o,
      circleResizer: s,
      closeButton: a,
      counter: i
    }) => {
      t.getSource(d) ? t.getSource(d).setData({
        type: "FeatureCollection",
        features: [e, o, s, a, i]
      }) : (t.addSource(d, {
        type: "geojson",
        data: {
          type: "FeatureCollection",
          features: [
            e,
            o,
            s,
            a,
            i
          ]
        }
      }), t.addLayer({
        id: n.CIRCLE_BORDER,
        type: "line",
        source: d,
        paint: {
          "line-color": r.borderColor,
          "line-opacity": r.borderOpacity,
          "line-width": r.borderWidth,
          "line-offset": 3
        },
        layout: {
          visibility: g()
        },
        filter: ["==", "bufferType", "main"],
        metadata: { mbLayerId: r.id }
      }), t.addLayer({
        id: n.CIRCLE_BACKGROUND,
        type: "fill",
        source: d,
        paint: {
          "fill-color": r.backgroundColor,
          "fill-opacity": r.backgroundOpacity
        },
        layout: {
          visibility: g()
        },
        filter: ["==", "bufferType", "main"],
        metadata: { mbLayerId: r.id }
      }), t.addLayer({
        id: n.RESIZER,
        type: "symbol",
        source: d,
        layout: {
          visibility: g(r.resizable),
          "icon-image": "BufferCircleResizerSVG",
          "icon-size": 1,
          "icon-offset": [2, 2],
          "icon-allow-overlap": !0
        },
        filter: ["==", "bufferType", "resizer"],
        metadata: { mbLayerId: r.id }
      }), t.addLayer({
        id: n.CENTER_POINT,
        type: "symbol",
        source: d,
        layout: {
          visibility: g(),
          "icon-image": "BufferCircleCenterSVG",
          "icon-size": 1,
          "icon-allow-overlap": !0
        },
        filter: ["==", "bufferType", "center"],
        metadata: { mbLayerId: r.id }
      }), t.addLayer({
        id: n.CLOSE_BUTTON,
        type: "symbol",
        source: d,
        layout: {
          visibility: g(r.closable),
          "icon-image": B,
          "icon-size": r.closeSize,
          "icon-offset": r.closeOffset,
          "icon-allow-overlap": !0
        },
        filter: ["==", "bufferType", "close"],
        metadata: { mbLayerId: r.id }
      }), t.addLayer({
        id: n.DISTANCE_COUNTER,
        type: "symbol",
        source: d,
        paint: {
          "text-color": r.textColor
        },
        layout: {
          visibility: g(r.countable),
          "text-font": r.textFonts,
          "text-size": r.textSize,
          "text-field": ["get", "text"],
          "text-allow-overlap": !0,
          "text-offset": [2, 0]
        },
        filter: ["==", "bufferType", "counter"],
        metadata: { mbLayerId: r.id }
      }));
    }, P = (e) => {
      window.requestAnimationFrame(() => {
        oe(re(e));
      });
    }, F = (e) => {
      u = e, P(u);
    }, ne = () => {
      t = U(), b = r.radius, K(), f = t.getCanvasContainer(), q(), F(r.center);
    }, { getMapboxInstance: U } = Te(ne);
    Se(U, n, r), z(
      () => r.center,
      (e, o) => {
        (e == null ? void 0 : e.join()) !== (o == null ? void 0 : o.join()) && (u = e, P(u));
      }
    ), z(
      () => r.radius,
      (e) => {
        R = e, b = e, P(u);
      }
    ), z(
      () => r.visible,
      () => {
        V();
      }
    );
    const se = () => {
      ae(), ie(), ce(), Z(), t = null;
    }, ae = () => {
      Object.keys(n).forEach((e) => {
        t.getLayer(n[e]) && t.removeLayer(n[e]);
      });
    }, ie = () => {
      t.removeSource(d);
    }, ce = () => {
      _.value.forEach((e) => {
        t.hasImage(e.name) && t.removeImage(e.name);
      });
    };
    return Ce(() => {
      se();
    }), (e, o) => (Le(), be(Re(Pe), {
      images: _.value,
      class: "mb-buffer-circle-layer-v2"
    }, null, 8, ["images"]));
  }
});
export {
  Ve as default
};
