import { defineComponent as le, ref as ce, watch as z, onBeforeUnmount as ue, openBlock as fe, createBlock as me, unref as de } from "vue";
import * as B from "@turf/helpers";
import pe from "@turf/circle";
import w from "@turf/distance";
import S from "@turf/destination";
import { bufferImages as ye, BUFFER_LAYER_ADDITIONAL as ge, bufferTuffOptions as L } from "../../buffer-layer/src/constants.mjs";
import { useBufferLayer as Ce } from "../../buffer-layer/src/use-buffer-layer.mjs";
import { handleCloseImage as Le, generateDotImage as P } from "../../buffer-layer/src/utils.mjs";
import { MbImageLoader as be } from "../../image-loader/index.mjs";
import { bufferCircleLayerProps as Re, bufferCircleLayerEmits as Ee } from "./buffer-circle-layer.mjs";
import { usePropsWatcher as Ie } from "./use-buffer-circle.mjs";
import { createBufferCircleLayer as he } from "./utils.mjs";
import { useMapCreated as ve } from "../../map/src/use-map.mjs";
const _e = {
  name: "MbBufferCircleLayer"
}, Ne = le({
  ..._e,
  props: Re,
  emits: Ee,
  setup(A, { emit: N }) {
    const t = A, m = N, { getVisibility: d } = Ce(t), T = "circle-close", _ = ce(
      Le(ye(T), t.closeIconUrl)
    );
    let f = 0, g = t.radius, n = [], b = [], r, i, C = !1, l, p = !1, y = !1;
    const { BUFFER_CIRCLE_LAYER: s, BUFFER_CIRCLE_SOURCE: u } = he(), M = () => {
      _.value.push(
        P(
          "BufferCircleCenterSVG",
          t.centerColor,
          t.centerRadius
        ),
        P(
          "BufferCircleResizerSVG",
          t.resizerColor,
          t.resizerRadius
        )
      );
    }, G = () => {
      Object.keys(s).forEach((e) => {
        r.getLayer(s[e]) && r.setLayoutProperty(
          s[e],
          "visibility",
          d(t[ge[e]])
        );
      });
    }, a = (e, o, c) => {
      typeof o == "string" ? (r.on(e, o, c), b.push({
        event: e,
        target: o,
        handler: c
      })) : (r.on(e, o), b.push({
        event: e,
        handler: o
      }));
    }, k = () => {
      b.forEach((e) => {
        e.target ? r.off(
          e.event,
          e.target,
          e.handler
        ) : r.off(e.event, e.handler);
      }), b = [];
    }, K = () => {
      a(
        "mouseenter",
        s.CIRCLE_BACKGROUND,
        D
      ), a(
        "mouseleave",
        s.CIRCLE_BACKGROUND,
        Z
      ), a("mousedown", s.CIRCLE_BACKGROUND, H), a("touchstart", s.CIRCLE_BACKGROUND, $), a("mouseenter", s.RESIZER, V), a("mouseleave", s.RESIZER, W), a("mousedown", s.RESIZER, Y), a("touchstart", s.RESIZER, q), a("click", s.CLOSE_BUTTON, (e) => {
        m("close", e);
      });
    }, D = () => {
      i.style.cursor = "move", C = !0, r.dragPan.disable(), m("mouseenter");
    }, Z = () => {
      i.style.cursor = "", C = !1, r.dragPan.enable(), m("mouseleave");
    }, V = () => {
      i.style.cursor = "nwse-resize", C = !0, r.dragPan.disable(), m("mouseenter");
    }, W = (e) => {
      w(
        [e.lngLat.lng, e.lngLat.lat],
        n
      ) > f ? (i.style.cursor = "", C = !1, r.dragPan.enable(), m("mouseleave")) : D();
    }, Y = (e) => {
      C && (l = e.lngLat, p = !0, y = !1, i.style.cursor = "nwse-resize", a("mousemove", R), r.once("mouseup", O));
    }, q = (e) => {
      e.points.length === 1 && (e.preventDefault(), l = e.lngLat, p = !0, y = !1, a("touchmove", R), r.once("touchend", (o) => {
        O(), r.dragPan.enable();
      }));
    }, H = (e) => {
      !C || !t.draggable || (l = e.lngLat, y = !0, p = !1, i.style.cursor = "grab", a("mousemove", E), r.once("mouseup", U));
    }, $ = (e) => {
      e.points.length !== 1 || !t.draggable || (e.preventDefault(), l = e.lngLat, y = !0, p = !1, a("touchmove", E), r.once("touchend", (o) => {
        U(), r.dragPan.enable();
      }));
    }, R = (e) => {
      if (!p) return;
      i.style.cursor = "nwse-resize";
      const o = e.lngLat.lat - l.lat, c = w(
        B.point([l.lng, l.lat]),
        B.point([e.lngLat.lng, e.lngLat.lat]),
        L
      );
      l = { lng: e.lngLat.lng, lat: e.lngLat.lat }, f += c * (o > 0 ? 1 : -1), g = Math.abs(+f.toFixed(1)), I(n);
    }, O = () => {
      p && (i.style.cursor = "", p = !1, m("update", {
        center: n,
        radius: g
      }), r.off("mousemove", R), r.off("touchmove", R));
    }, E = (e) => {
      if (!y) return;
      i.style.cursor = "grabbing";
      const o = e.lngLat.lng - l.lng, c = e.lngLat.lat - l.lat;
      l = { lng: e.lngLat.lng, lat: e.lngLat.lat }, F([n[0] + o, n[1] + c]);
    }, U = () => {
      y && (i.style.cursor = "", y = !1, r.off(
        "mousemove",
        s.CIRCLE_BACKGROUND,
        E
      ), r.off(
        "touchmove",
        s.CIRCLE_BACKGROUND,
        E
      ), m("update", {
        center: n,
        radius: g
      }));
    }, j = (e) => {
      const o = B.point([...e]), c = pe(o, f, {
        ...L,
        properties: { bufferType: "main" }
      }), h = S(o, f, -45, L), v = S(
        o,
        f,
        45,
        L
      ).geometry.coordinates, oe = S(
        o,
        f,
        90,
        L
      ).geometry.coordinates, se = {
        type: "Feature",
        properties: {
          bufferType: "close"
        },
        geometry: {
          type: "Point",
          coordinates: v
        }
      }, ae = {
        type: "Feature",
        properties: {
          bufferType: "resizer"
        },
        geometry: {
          type: "Point",
          coordinates: [...h.geometry.coordinates]
        }
      }, ne = {
        type: "Feature",
        properties: {
          bufferType: "center"
        },
        geometry: {
          type: "Point",
          coordinates: e
        }
      }, ie = {
        type: "Feature",
        properties: {
          bufferType: "counter",
          text: t.formatter ? t.formatter(g) : `${g}km`
        },
        geometry: {
          type: "Point",
          coordinates: oe
        }
      };
      return {
        circleMain: c,
        circleCenter: ne,
        circleResizer: ae,
        closeButton: se,
        counter: ie
      };
    }, J = ({
      circleMain: e,
      circleCenter: o,
      circleResizer: c,
      closeButton: h,
      counter: v
    }) => {
      r.getSource(u) ? r.getSource(u).setData({
        type: "FeatureCollection",
        features: [e, o, c, h, v]
      }) : (r.addSource(u, {
        type: "geojson",
        data: {
          type: "FeatureCollection",
          features: [
            e,
            o,
            c,
            h,
            v
          ]
        }
      }), r.addLayer({
        id: s.CIRCLE_BORDER,
        type: "line",
        source: u,
        paint: {
          "line-color": t.borderColor,
          "line-opacity": t.borderOpacity,
          "line-width": t.borderWidth,
          "line-offset": 3
        },
        layout: {
          visibility: d()
        },
        filter: ["==", "bufferType", "main"],
        metadata: { mbLayerId: t.id }
      }), r.addLayer({
        id: s.CIRCLE_BACKGROUND,
        type: "fill",
        source: u,
        paint: {
          "fill-color": t.backgroundColor,
          "fill-opacity": t.backgroundOpacity
        },
        layout: {
          visibility: d()
        },
        filter: ["==", "bufferType", "main"],
        metadata: { mbLayerId: t.id }
      }), r.addLayer({
        id: s.RESIZER,
        type: "symbol",
        source: u,
        layout: {
          visibility: d(t.resizable),
          "icon-image": "BufferCircleResizerSVG",
          "icon-size": 1,
          "icon-offset": [2, 2],
          "icon-allow-overlap": !0
        },
        filter: ["==", "bufferType", "resizer"],
        metadata: { mbLayerId: t.id }
      }), r.addLayer({
        id: s.CENTER_POINT,
        type: "symbol",
        source: u,
        layout: {
          visibility: d(),
          "icon-image": "BufferCircleCenterSVG",
          "icon-size": 1,
          "icon-allow-overlap": !0
        },
        filter: ["==", "bufferType", "center"],
        metadata: { mbLayerId: t.id }
      }), r.addLayer({
        id: s.CLOSE_BUTTON,
        type: "symbol",
        source: u,
        layout: {
          visibility: d(t.closable),
          "icon-image": T,
          "icon-size": t.closeSize,
          "icon-offset": t.closeOffset,
          "icon-allow-overlap": !0
        },
        filter: ["==", "bufferType", "close"],
        metadata: { mbLayerId: t.id }
      }), r.addLayer({
        id: s.DISTANCE_COUNTER,
        type: "symbol",
        source: u,
        paint: {
          "text-color": t.textColor
        },
        layout: {
          visibility: d(t.countable),
          "text-font": t.textFonts,
          "text-size": t.textSize,
          "text-field": ["get", "text"],
          "text-allow-overlap": !0,
          "text-offset": [2, 0]
        },
        filter: ["==", "bufferType", "counter"],
        metadata: { mbLayerId: t.id }
      }));
    }, I = (e) => {
      window.requestAnimationFrame(() => {
        J(j(e));
      });
    }, F = (e) => {
      n = e, I(n);
    }, Q = () => {
      r = x(), f = t.radius, M(), i = r.getCanvasContainer(), K(), F(t.center);
    }, { getMapboxInstance: x } = ve(Q);
    Ie(x, s, t), z(
      () => t.center,
      (e, o) => {
        (e == null ? void 0 : e.join()) !== (o == null ? void 0 : o.join()) && (n = e, I(n));
      }
    ), z(
      () => t.radius,
      (e) => {
        g = e, f = e, I(n);
      }
    ), z(
      () => t.visible,
      () => {
        G();
      }
    );
    const X = () => {
      ee(), te(), re(), k(), r = null;
    }, ee = () => {
      Object.keys(s).forEach((e) => {
        r.getLayer(s[e]) && r.removeLayer(s[e]);
      });
    }, te = () => {
      r.removeSource(u);
    }, re = () => {
      _.value.forEach((e) => {
        r.hasImage(e.name) && r.removeImage(e.name);
      });
    };
    return ue(() => {
      X();
    }), (e, o) => (fe(), me(de(be), {
      images: _.value,
      class: "mb-buffer-circle-layer"
    }, null, 8, ["images"]));
  }
});
export {
  Ne as default
};
