import { defineComponent as Ce, ref as Se, watch as S, onBeforeUnmount as Te, openBlock as ve, createBlock as _e, unref as xe } from "vue";
import * as A from "@turf/helpers";
import he from "@turf/area";
import Ae from "@turf/ellipse";
import Be from "@turf/distance";
import T from "@turf/destination";
import Z from "@turf/bearing";
import Pe from "@turf/boolean-point-in-polygon";
import { bufferImages as Oe, BUFFER_LAYER_ADDITIONAL as ze, bufferTuffOptions as b } from "../../buffer-layer/src/constants.mjs";
import { useBufferLayer as De } from "../../buffer-layer/src/use-buffer-layer.mjs";
import { handleCloseImage as Fe, generateDotImage as B } from "../../buffer-layer/src/utils.mjs";
import { MbImageLoader as Me } from "../../image-loader/index.mjs";
import { bufferEllipseLayerProps as Ue, bufferEllipseLayerEmits as Ne } from "./buffer-ellipse-layer.mjs";
import { usePropsWatcher as we } from "./use-buffer-ellipse.mjs";
import { createBufferEllipseLayer as Ge, tuffEllipseOptions as ke, BUFFER_ELLIPSE_RESIZER_OPTIONS as X, getLayerName as q, getCursorByResizerName as P, angleToDegree as H, square as V, degreeToAngle as Ye, getYByXFunc as Ke } from "./utils.mjs";
import { useMapCreated as Ze } from "../../map/src/use-map.mjs";
const Xe = {
  name: "MbBufferEllipseLayer"
}, it = Ce({
  ...Xe,
  props: Ue,
  emits: Ne,
  setup(W, { emit: $ }) {
    const t = W, p = $, { getVisibility: m } = De(t), O = "ellipse-close", h = Se(
      Fe(Oe(O), t.closeIconUrl)
    );
    let u = t.xSemiAxis, y = t.ySemiAxis, f = t.angle, a = [], v = [], o, l, L = !1, R, I = !1, C = !1, _, z;
    const { BUFFER_ELLIPSE_LAYER: s, BUFFER_ELLIPSE_SOURCE: c } = Ge(), j = () => {
      h.value.push(
        B(
          "BufferEllipseCenterSVG",
          t.centerColor,
          t.centerRadius
        ),
        B(
          "BufferEllipseResizerSVG",
          t.resizerColor,
          t.resizerRadius
        ),
        B(
          "BufferEllipseRotaterSVG",
          t.rotaterColor,
          t.resizerRadius
        )
      );
    }, J = () => {
      Object.keys(s).forEach((e) => {
        o.getLayer(s[e]) && o.setLayoutProperty(
          s[e],
          "visibility",
          m(t[ze[e]])
        );
      });
    }, i = (e, r, n) => {
      typeof r == "string" ? (o.on(e, r, n), v.push({
        event: e,
        target: r,
        handler: n
      })) : (o.on(e, r), v.push({
        event: e,
        handler: r
      }));
    }, Q = () => {
      v.forEach((e) => {
        e.target ? o.off(
          e.event,
          e.target,
          e.handler
        ) : o.off(e.event, e.handler);
      }), v = [];
    }, ee = () => {
      i(
        "mouseenter",
        s.ELLIPSE_BACKGROUND,
        F
      ), i(
        "mouseleave",
        s.ELLIPSE_BACKGROUND,
        te
      ), i("mousedown", s.ELLIPSE_BACKGROUND, re), i("mouseenter", s.RESIZER, M), i("mouseleave", s.RESIZER, U), i("mousedown", s.RESIZER, N), i("mouseenter", s.ROTATER, M), i("mouseleave", s.ROTATER, U), i("mousedown", s.ROTATER, N), i("click", s.CLOSE_BUTTON, (e) => {
        p("close", e);
      });
    }, D = () => ({
      center: a,
      xSemiAxis: u,
      ySemiAxis: y,
      angle: f
    }), F = () => {
      l.style.cursor = "move", L = !0, o.dragPan.disable(), p("mouseenter");
    }, te = () => {
      l.style.cursor = "", L = !1, o.dragPan.enable(), p("mouseleave");
    }, M = (e) => {
      _ = q(e), l.style.cursor = P(q(e)), L = !0, o.dragPan.disable(), p("mouseenter");
    }, U = (e) => {
      const r = [e.lngLat.lng, e.lngLat.lat];
      Pe(r, z) ? F() : (l.style.cursor = "", L = !1, o.dragPan.enable(), p("mouseleave"));
    }, N = (e) => {
      L && (R = e.lngLat, I = !0, C = !1, l.style.cursor = P(_), i("mousemove", w), o.once("mouseup", oe));
    }, w = (e) => {
      if (!I) return;
      l.style.cursor = P(_);
      const r = Be(
        A.point([e.lngLat.lng, e.lngLat.lat]),
        A.point(a),
        b
      ), n = Z(a, [e.lngLat.lng, e.lngLat.lat]) - 90 - f;
      ({
        xResizer: () => {
          u = r * Math.abs(Math.cos(H(n)));
        },
        yResizer: () => {
          y = r * Math.abs(Math.sin(H(n)));
        },
        rotater: () => {
          f = Z(a, [e.lngLat.lng, e.lngLat.lat]) - 90;
        }
      })[_](), E(a);
    }, oe = () => {
      I && (l.style.cursor = "", I = !1, p("update", D()), o.off("mousemove", w));
    }, re = (e) => {
      !L || !t.draggable || (R = e.lngLat, C = !0, I = !1, l.style.cursor = "grab", i("mousemove", G), o.once("mouseup", se));
    }, G = (e) => {
      if (!C) return;
      l.style.cursor = "grabbing";
      const r = e.lngLat.lng - R.lng, n = e.lngLat.lat - R.lat;
      R = { lng: e.lngLat.lng, lat: e.lngLat.lat }, k([a[0] + r, a[1] + n]);
    }, se = () => {
      C && (l.style.cursor = "", C = !1, o.off(
        "mousemove",
        s.ELLIPSE_BACKGROUND,
        G
      ), p("update", D()));
    }, ne = (e) => {
      const r = u / 2, n = Ke(u, y)(r), d = Math.sqrt(V(r) + V(n)), g = Ye(Math.atan(r / n));
      return T(
        e,
        d,
        g + f,
        b
      ).geometry.coordinates;
    }, ae = (e) => {
      const r = A.point([...e]), n = Ae(r, u, y, {
        ...ke,
        angle: f,
        properties: { bufferType: "main" }
      });
      z = n;
      const d = T(
        r,
        u,
        -90 + f,
        b
      ), g = T(
        r,
        y,
        f,
        b
      ), x = T(
        r,
        u,
        90 + f,
        b
      ), pe = T(
        r,
        u,
        90 + f,
        b
      ).geometry.coordinates, K = (he(n) / 1e3 / 1e3).toFixed(2), ye = ne(r), de = {
        type: "Feature",
        properties: {
          bufferType: "close"
        },
        geometry: {
          type: "Point",
          coordinates: ye
        }
      }, ge = [d, g].map((Re, Ie) => ({
        type: "Feature",
        properties: {
          bufferType: "resizer",
          ...X[Ie]
        },
        geometry: {
          type: "Point",
          coordinates: [...Re.geometry.coordinates]
        }
      })), Le = {
        type: "Feature",
        properties: {
          bufferType: "rotater",
          ...X[2]
        },
        geometry: {
          type: "Point",
          coordinates: [...x.geometry.coordinates]
        }
      }, Ee = {
        type: "Feature",
        properties: {
          bufferType: "center"
        },
        geometry: {
          type: "Point",
          coordinates: e
        }
      }, be = {
        type: "Feature",
        properties: {
          bufferType: "counter",
          text: t.formatter ? t.formatter(K, u, y) : `${K} km2`
        },
        geometry: {
          type: "Point",
          coordinates: pe
        }
      };
      return {
        ellipseMain: n,
        ellipseCenter: Ee,
        ellipseResizer: ge,
        ellipseRotater: Le,
        closeButton: de,
        counter: be
      };
    }, ie = ({
      ellipseMain: e,
      ellipseCenter: r,
      ellipseResizer: n,
      ellipseRotater: d,
      closeButton: g,
      counter: x
    }) => {
      o.getSource(c) ? o.getSource(c).setData(
        {
          type: "FeatureCollection",
          features: [
            e,
            r,
            ...n,
            d,
            g,
            x
          ]
        }
      ) : (o.addSource(c, {
        type: "geojson",
        data: {
          type: "FeatureCollection",
          features: [
            e,
            r,
            ...n,
            d,
            g,
            x
          ]
        }
      }), o.addLayer({
        id: s.ELLIPSE_BORDER,
        type: "line",
        source: c,
        paint: {
          "line-color": t.borderColor,
          "line-opacity": t.borderOpacity,
          "line-width": t.borderWidth,
          "line-offset": 3
        },
        layout: {
          visibility: m()
        },
        filter: ["==", "bufferType", "main"],
        metadata: { mbLayerId: t.id }
      }), o.addLayer({
        id: s.ELLIPSE_BACKGROUND,
        type: "fill",
        source: c,
        paint: {
          "fill-color": t.backgroundColor,
          "fill-opacity": t.backgroundOpacity
        },
        layout: {
          visibility: m()
        },
        filter: ["==", "bufferType", "main"],
        metadata: { mbLayerId: t.id }
      }), o.addLayer({
        id: s.RESIZER,
        type: "symbol",
        source: c,
        layout: {
          visibility: m(t.resizable),
          "icon-image": ["get", "icon"],
          "icon-size": 1,
          "icon-offset": ["get", "icon-offset"],
          "icon-allow-overlap": !0
        },
        filter: ["==", "bufferType", "resizer"],
        metadata: { mbLayerId: t.id }
      }), o.addLayer({
        id: s.ROTATER,
        type: "symbol",
        source: c,
        layout: {
          visibility: m(t.rotatable),
          "icon-image": ["get", "icon"],
          "icon-size": 1,
          "icon-offset": ["get", "icon-offset"],
          "icon-allow-overlap": !0
        },
        filter: ["==", "bufferType", "rotater"],
        metadata: { mbLayerId: t.id }
      }), o.addLayer({
        id: s.CENTER_POINT,
        type: "symbol",
        source: c,
        layout: {
          visibility: m(),
          "icon-image": "BufferEllipseCenterSVG",
          "icon-size": 1,
          "icon-allow-overlap": !0
        },
        filter: ["==", "bufferType", "center"],
        metadata: { mbLayerId: t.id }
      }), o.addLayer({
        id: s.CLOSE_BUTTON,
        type: "symbol",
        source: c,
        layout: {
          visibility: m(t.closable),
          "icon-image": O,
          "icon-size": t.closeSize,
          "icon-offset": t.closeOffset,
          "icon-allow-overlap": !0
        },
        filter: ["==", "bufferType", "close"],
        metadata: { mbLayerId: t.id }
      }), o.addLayer({
        id: s.DISTANCE_COUNTER,
        type: "symbol",
        source: c,
        paint: {
          "text-color": t.textColor
        },
        layout: {
          visibility: m(t.countable),
          "text-font": t.textFonts,
          "text-size": t.textSize,
          "text-field": ["get", "text"],
          "text-allow-overlap": !0,
          "text-offset": [3, 0]
        },
        filter: ["==", "bufferType", "counter"],
        metadata: { mbLayerId: t.id }
      }));
    }, E = (e) => {
      window.requestAnimationFrame(() => {
        ie(ae(e || t.center));
      });
    }, k = (e) => {
      a = e, E(a);
    }, le = () => {
      o = Y(), l = o.getCanvasContainer(), j(), ee(), k(t.center);
    }, { getMapboxInstance: Y } = Ze(le);
    we(Y, s, t), S(
      () => t.center,
      (e, r) => {
        (e == null ? void 0 : e.join()) !== (r == null ? void 0 : r.join()) && (a = e, E(a));
      }
    ), S(
      () => t.xSemiAxis,
      (e) => {
        u = e, E(a);
      }
    ), S(
      () => t.ySemiAxis,
      (e) => {
        y = e, E(a);
      }
    ), S(
      () => t.angle,
      (e) => {
        f = e, E(a);
      }
    ), S(
      () => t.visible,
      () => {
        J();
      }
    );
    const ce = () => {
      ue(), fe(), me(), Q(), o = null;
    }, ue = () => {
      Object.keys(s).forEach((e) => {
        o.getLayer(s[e]) && o.removeLayer(s[e]);
      });
    }, fe = () => {
      o.removeSource(c);
    }, me = () => {
      h.value.forEach((e) => {
        o.hasImage(e.name) && o.removeImage(e.name);
      });
    };
    return Te(() => {
      ce();
    }), (e, r) => (ve(), _e(xe(Me), {
      images: h.value,
      class: "mb-buffer-ellipse-layer"
    }, null, 8, ["images"]));
  }
});
export {
  it as default
};
