import { defineComponent as ce, ref as A, watch as U, onBeforeUnmount as me, openBlock as pe, createBlock as de, unref as ye } from "vue";
import * as ge from "@turf/helpers";
import Le from "@turf/area";
import ve from "@turf/boolean-point-in-polygon";
import be from "@turf/buffer";
import w from "@turf/destination";
import { bufferImages as Ee, BUFFER_LAYER_ADDITIONAL as Ie, bufferTuffOptions as x } from "../../buffer-layer/src/constants.mjs";
import { useBufferLayer as Re } from "../../buffer-layer/src/use-buffer-layer.mjs";
import { handleCloseImage as Se, generateDotImage as he } from "../../buffer-layer/src/utils.mjs";
import { MbImageLoader as Ce } from "../../image-loader/index.mjs";
import { bufferLineLayerProps as _e, bufferLineLayerEmits as Ne } from "./buffer-line-layer.mjs";
import { usePropsWatcher as xe } from "./use-buffer-line.mjs";
import { createBufferLineLayer as Oe } from "./utils.mjs";
import { useMapCreated as Be } from "../../map/src/use-map.mjs";
const De = {
  name: "MbBufferLineLayer"
}, Ze = ce({
  ...De,
  props: _e,
  emits: Ne,
  setup(G, { emit: J }) {
    const o = G, c = J, { getVisibility: g } = Re(o), O = "line-close", C = A(
      Se(Ee(O), o.closeIconUrl)
    ), r = A(
      o.manual ? [] : JSON.parse(JSON.stringify(o.lineString))
    );
    let l, R, S = [], t, s, L = !1, v, b = !1, E = !1, B = "";
    const { BUFFER_LINE_LAYER: a, BUFFER_LINE_SOURCE: u } = Oe(), K = () => {
      C.value.push(
        he(
          "BufferLineResizerSVG",
          o.resizerColor,
          o.resizerRadius
        )
      );
    }, V = () => {
      Object.keys(a).forEach((e) => {
        t.getLayer(a[e]) && t.setLayoutProperty(
          a[e],
          "visibility",
          g(o[Ie[e]])
        );
      });
    }, f = (e, n, i) => {
      typeof n == "string" ? (t.on(e, n, i), S.push({
        event: e,
        target: n,
        handler: i
      })) : (t.on(e, n), S.push({
        event: e,
        handler: n
      }));
    }, Z = () => {
      S.forEach((e) => {
        e.target ? t.off(
          e.event,
          e.target,
          e.handler
        ) : t.off(e.event, e.handler);
      }), S = [], D();
    }, W = () => {
      f("mouseenter", a.LINE_BACKGROUND, M), f("mouseleave", a.LINE_BACKGROUND, Y), f("mousedown", a.LINE_BACKGROUND, j), f("mouseenter", a.RESIZER, $), f("mouseleave", a.RESIZER, q), f("mousedown", a.RESIZER, H), f("click", a.CLOSE_BUTTON, (e) => {
        c("close", e);
      }), X();
    }, X = () => {
      R = {}, o.manual && (t.on("click", T), t.on("dblclick", _), document.addEventListener("keydown", z));
    }, D = () => {
      t.off("click", T), t.off("dblclick", _), document.removeEventListener("keydown", z);
    }, T = (e) => {
      if (e.preventDefault(), e.originalEvent.cancelBubble = !0, R.x !== e.point.x || R.y !== e.point.y) {
        const { lng: n, lat: i } = e.lngLat;
        r.value.push([n, i]), r.value.length === 1 ? r.value.push(r.value[0]) : r.value.length > 2 && r.value[0] === r.value[1] && r.value.splice(1, 1), h();
      }
      R = e.point;
    }, _ = (e) => {
      e.preventDefault(), e.originalEvent && (e.originalEvent.cancelBubble = !0), D(), c("complete", {
        lineString: r.value,
        polygon: l
      });
    }, z = (e) => {
      const n = e.keyCode;
      n === 27 || n === 8 || n === 46 ? (r.value.length > 2 ? r.value.splice(-1, 1) : r.value.length === 2 && (r.value[0] !== r.value[1] ? r.value.splice(1, 1, r.value[0]) : r.value.splice(0, 2)), h()) : n === 13 && _(e);
    }, M = () => {
      s.style.cursor = "move", L = !0, t.dragPan.disable(), c("mouseenter");
    }, Y = () => {
      s.style.cursor = "", L = !1, t.dragPan.enable(), c("mouseleave");
    }, $ = (e) => {
      B = e.features[0].properties.idx, s.style.cursor = "move", L = !0, t.dragPan.disable(), c("mouseenter");
    }, q = (e) => {
      if (!l) return;
      const n = ge.point([e.lngLat.lng, e.lngLat.lat]);
      ve(n, l) ? (s.style.cursor = "", L = !1, t.dragPan.enable(), c("mouseleave")) : M();
    }, H = (e) => {
      L && (v = e.lngLat, b = !0, E = !1, s.style.cursor = "move", f("mousemove", P), t.once("mouseup", Q));
    }, P = (e) => {
      if (!b) return;
      s.style.cursor = "move";
      const n = +B;
      r.value.splice(n, 1, [e.lngLat.lng, e.lngLat.lat]), v = { lng: e.lngLat.lng, lat: e.lngLat.lat }, N();
    }, Q = (e) => {
      b && (s.style.cursor = "", b = !1, c("update", {
        lineString: r.value,
        polygon: l
      }), t.off("mousemove", P));
    }, j = (e) => {
      !L || !o.draggable || (v = e.lngLat, E = !0, b = !1, s.style.cursor = "grab", f("mousemove", k), t.once("mouseup", ee));
    }, k = (e) => {
      if (!E) return;
      s.style.cursor = "grabbing";
      const n = e.lngLat.lng - v.lng, i = e.lngLat.lat - v.lat;
      v = { lng: e.lngLat.lng, lat: e.lngLat.lat }, r.value.forEach((m) => {
        m[0] += n, m[1] += i;
      }), h();
    }, ee = (e) => {
      E && (s.style.cursor = "", E = !1, t.off(
        "mousemove",
        a.LINE_BACKGROUND,
        k
      ), c("update", {
        lineString: r.value,
        polygon: l
      }));
    }, te = () => {
      const e = r.value.reduce(
        (d, y) => y[0] > d[0] ? y : d,
        [-Number.MAX_SAFE_INTEGER, 0]
      ), n = r.value.reduce(
        (d, y) => y[1] > d[1] ? y : d,
        [0, -Number.MAX_SAFE_INTEGER]
      ), i = w(n, 0, 0, x).geometry.coordinates, m = w(
        e,
        0,
        0,
        x
      ).geometry.coordinates, I = {
        type: "Feature",
        properties: {
          bufferType: "main"
        },
        geometry: {
          type: "LineString",
          coordinates: r.value
        }
      };
      let p = "";
      r.value.length ? (l = be(
        JSON.parse(JSON.stringify(I)),
        o.radius,
        x
      ), l.properties.bufferType = "buffer", p = (Le(l) / 1e3 / 1e3).toFixed(2)) : l = void 0;
      const le = {
        type: "Feature",
        properties: {
          bufferType: "close"
        },
        geometry: {
          type: "Point",
          coordinates: i
        }
      }, ue = r.value.map((d, y) => ({
        type: "Feature",
        properties: {
          bufferType: "resizer",
          idx: `${y}`
        },
        geometry: {
          type: "Point",
          coordinates: [...d]
        }
      })), fe = {
        type: "Feature",
        properties: {
          bufferType: "counter",
          text: o.formatter ? o.formatter(p) : `${p} km2`
        },
        geometry: {
          type: "Point",
          coordinates: m
        }
      };
      return {
        lineMain: I,
        bufferMain: l,
        resizers: ue,
        closeButton: le,
        counter: fe
      };
    }, oe = ({
      lineMain: e,
      bufferMain: n,
      resizers: i,
      closeButton: m,
      counter: I
    }) => {
      t.getSource(u) ? t.getSource(u).setData({
        type: "FeatureCollection",
        features: [
          e,
          n,
          ...i,
          m,
          I
        ].filter((p) => !!p)
      }) : (t.addSource(u, {
        type: "geojson",
        data: {
          type: "FeatureCollection",
          features: [
            e,
            n,
            ...i,
            m,
            I
          ].filter((p) => !!p)
        }
      }), t.addLayer({
        id: a.LINE_BORDER,
        type: "line",
        source: u,
        paint: {
          "line-color": o.borderColor,
          "line-opacity": o.borderOpacity,
          "line-width": o.borderWidth,
          "line-offset": 3
        },
        layout: {
          visibility: g()
        },
        filter: ["==", "bufferType", "main"],
        metadata: { mbLayerId: o.id }
      }), t.addLayer({
        id: a.LINE_BACKGROUND,
        type: "fill",
        source: u,
        paint: {
          "fill-color": o.backgroundColor,
          "fill-opacity": o.backgroundOpacity
        },
        layout: {
          visibility: g()
        },
        filter: ["==", "bufferType", "buffer"],
        metadata: { mbLayerId: o.id }
      }), t.addLayer({
        id: a.RESIZER,
        type: "symbol",
        source: u,
        layout: {
          visibility: g(o.resizable),
          "icon-image": "BufferLineResizerSVG",
          "icon-size": 1,
          "icon-offset": ["get", "offset"],
          "icon-allow-overlap": !0
        },
        filter: ["==", "bufferType", "resizer"],
        metadata: { mbLayerId: o.id }
      }), t.addLayer({
        id: a.CLOSE_BUTTON,
        type: "symbol",
        source: u,
        layout: {
          visibility: g(o.closable),
          "icon-image": O,
          "icon-size": o.closeSize,
          "icon-offset": o.closeOffset,
          "icon-allow-overlap": !0
        },
        filter: ["==", "bufferType", "close"],
        metadata: { mbLayerId: o.id }
      }), t.addLayer({
        id: a.DISTANCE_COUNTER,
        type: "symbol",
        source: u,
        paint: {
          "text-color": o.textColor
        },
        layout: {
          visibility: g(o.countable),
          "text-font": o.textFonts,
          "text-size": o.textSize,
          "text-field": ["get", "text"],
          "text-allow-overlap": !0,
          "text-offset": [3.5, 0]
        },
        filter: ["==", "bufferType", "counter"],
        metadata: { mbLayerId: o.id }
      }));
    }, N = () => {
      window.requestAnimationFrame(() => {
        oe(te());
      });
    }, h = () => {
      N();
    }, re = () => {
      t = F(), s = t.getCanvasContainer(), K(), W(), h();
    }, { getMapboxInstance: F } = Be(re);
    xe(F, a, o), U(
      () => o.lineString,
      (e) => {
        r.value = JSON.parse(JSON.stringify(e)), N();
      },
      {
        deep: !0
      }
    ), U(
      () => o.visible,
      () => {
        V();
      }
    );
    const ne = () => {
      ae(), ie(), se(), Z(), t = null;
    }, ae = () => {
      Object.keys(a).forEach((e) => {
        t.getLayer(a[e]) && t.removeLayer(a[e]);
      });
    }, ie = () => {
      t.removeSource(u);
    }, se = () => {
      C.value.forEach((e) => {
        t.hasImage(e.name) && t.removeImage(e.name);
      });
    };
    return me(() => {
      ne();
    }), (e, n) => (pe(), de(ye(Ce), {
      images: C.value,
      class: "mb-buffer-line-layer"
    }, null, 8, ["images"]));
  }
});
export {
  Ze as default
};
