import { defineComponent as ge, ref as k, watch as A, onBeforeUnmount as de, openBlock as ve, createBlock as Le, unref as be } from "vue";
import * as I from "@turf/helpers";
import Ee from "@turf/area";
import Pe from "@turf/boolean-point-in-polygon";
import Oe from "@turf/center";
import U from "@turf/destination";
import { bufferImages as Ce, BUFFER_LAYER_ADDITIONAL as Re, bufferTuffOptions as w } from "../../buffer-layer/src/constants.mjs";
import { useBufferLayer as he } from "../../buffer-layer/src/use-buffer-layer.mjs";
import { handleCloseImage as Ie, generateDotImage as Y } from "../../buffer-layer/src/utils.mjs";
import { MbImageLoader as _e } from "../../image-loader/index.mjs";
import { bufferPolygonLayerProps as Ne, bufferPolygonLayerEmits as Se } from "./buffer-polygon-layer.mjs";
import { usePropsWatcher as xe } from "./use-buffer-polygon.mjs";
import { formatPolyData as K, createBufferPolygonLayer as Be } from "./utils.mjs";
import { useMapCreated as Te } from "../../map/src/use-map.mjs";
const De = {
  name: "MbBufferPolygonLayer"
}, He = ge({
  ...De,
  props: Ne,
  emits: Se,
  setup(V, { emit: J }) {
    const o = V, c = J, { getVisibility: y } = he(o), _ = "polygon-close", C = k(
      Ie(Ce(_), o.closeIconUrl)
    ), r = k(
      o.manual ? [] : K(JSON.parse(JSON.stringify(o.polygon)))
    );
    let E, P = [], t, s, g = !1, d, L = !1, b = !1, N = "";
    const { BUFFER_POLYGON_LAYER: a, BUFFER_POLYGON_SOURCE: i } = Be(), Z = () => {
      C.value.push(
        Y(
          "BufferPolygonCenterSVG",
          o.centerColor,
          o.centerRadius
        ),
        Y(
          "BufferPolygonResizerSVG",
          o.resizerColor,
          o.resizerRadius
        )
      );
    }, H = () => {
      Object.keys(a).forEach((e) => {
        t.getLayer(a[e]) && t.setLayoutProperty(
          a[e],
          "visibility",
          y(o[Re[e]])
        );
      });
    }, u = (e, n, l) => {
      typeof n == "string" ? (t.on(e, n, l), P.push({
        event: e,
        target: n,
        handler: l
      })) : (t.on(e, n), P.push({
        event: e,
        handler: n
      }));
    }, W = () => {
      P.forEach((e) => {
        e.target ? t.off(
          e.event,
          e.target,
          e.handler
        ) : t.off(e.event, e.handler);
      }), P = [], S();
    }, X = () => {
      u(
        "mouseenter",
        a.POLYGON_BACKGROUND,
        T
      ), u(
        "mouseleave",
        a.POLYGON_BACKGROUND,
        q
      ), u("mousedown", a.POLYGON_BACKGROUND, te), u("mouseenter", a.RESIZER, Q), u("mouseleave", a.RESIZER, j), u("mousedown", a.RESIZER, ee), u("click", a.CLOSE_BUTTON, (e) => {
        c("close", e);
      }), $();
    }, $ = () => {
      E = {}, o.manual && (t.on("click", x), t.on("dblclick", R), document.addEventListener("keydown", B));
    }, S = () => {
      t.off("click", x), t.off("dblclick", R), document.removeEventListener("keydown", B);
    }, x = (e) => {
      if (e.preventDefault(), e.originalEvent.cancelBubble = !0, E.x !== e.point.x || E.y !== e.point.y) {
        const { lng: n, lat: l } = e.lngLat;
        r.value.splice(
          r.value.length ? r.value.length - 1 : 0,
          0,
          [n, l]
        ), r.value.length === 1 && r.value.push(r.value[0]), O();
      }
      E = e.point;
    }, R = (e) => {
      e.preventDefault(), e.originalEvent && (e.originalEvent.cancelBubble = !0), S(), c("complete", {
        polygon: r.value
      });
    }, B = (e) => {
      const n = e.keyCode;
      n === 27 || n === 8 || n === 46 ? (r.value.length > 2 ? r.value.splice(-2, 1) : r.value.length === 2 && r.value.splice(0, 2), O()) : n === 13 && R(e);
    }, T = () => {
      s.style.cursor = "move", g = !0, t.dragPan.disable(), c("mouseenter");
    }, q = () => {
      s.style.cursor = "", g = !1, t.dragPan.enable(), c("mouseleave");
    }, Q = (e) => {
      N = e.features[0].properties.idx, s.style.cursor = "move", g = !0, t.dragPan.disable(), c("mouseenter");
    }, j = (e) => {
      if (r.value.length < 4) return;
      const n = I.point([e.lngLat.lng, e.lngLat.lat]), l = I.polygon([r.value]);
      Pe(n, l) ? T() : (s.style.cursor = "", g = !1, t.dragPan.enable(), c("mouseleave"));
    }, ee = (e) => {
      g && (d = e.lngLat, L = !0, b = !1, s.style.cursor = "move", u("mousemove", D), t.once("mouseup", oe));
    }, D = (e) => {
      if (!L) return;
      s.style.cursor = "move";
      const n = +N;
      r.value.splice(n, 1, [e.lngLat.lng, e.lngLat.lat]), n === 0 ? r.value.splice(-1, 1, [e.lngLat.lng, e.lngLat.lat]) : n === r.value.length - 1 && r.value.splice(0, 1, [e.lngLat.lng, e.lngLat.lat]), d = { lng: e.lngLat.lng, lat: e.lngLat.lat }, h();
    }, oe = () => {
      L && (s.style.cursor = "", L = !1, c("update", {
        polygon: r.value
      }), t.off("mousemove", D));
    }, te = (e) => {
      !g || !o.draggable || (d = e.lngLat, b = !0, L = !1, s.style.cursor = "grab", u("mousemove", z), t.once("mouseup", re));
    }, z = (e) => {
      if (!b) return;
      s.style.cursor = "grabbing";
      const n = e.lngLat.lng - d.lng, l = e.lngLat.lat - d.lat;
      d = { lng: e.lngLat.lng, lat: e.lngLat.lat }, r.value.forEach((f, v) => {
        v !== r.value.length - 1 && (f[0] += n, f[1] += l);
      }), O();
    }, re = () => {
      b && (s.style.cursor = "", b = !1, t.off(
        "mousemove",
        a.POLYGON_BACKGROUND,
        z
      ), c("update", {
        polygon: r.value
      }));
    }, ne = () => {
      const e = r.value.length ? Oe(I.points(r.value)) : void 0, n = r.value.reduce(
        (m, p) => p[0] > m[0] ? p : m,
        [-Number.MAX_SAFE_INTEGER, 0]
      ), l = r.value.reduce(
        (m, p) => p[1] > m[1] ? p : m,
        [0, -Number.MAX_SAFE_INTEGER]
      ), f = U(l, 0, 0, w).geometry.coordinates, v = U(
        n,
        0,
        0,
        w
      ).geometry.coordinates, F = {
        type: "Feature",
        properties: {
          bufferType: "main"
        },
        geometry: {
          type: "Polygon",
          coordinates: [r.value]
        }
      }, M = (Ee(F) / 1e3 / 1e3).toFixed(2), fe = {
        type: "Feature",
        properties: {
          bufferType: "close"
        },
        geometry: {
          type: "Point",
          coordinates: f
        }
      }, ye = r.value.map((m, p) => ({
        type: "Feature",
        properties: {
          bufferType: "resizer",
          idx: `${p}`
        },
        geometry: {
          type: "Point",
          coordinates: [...m]
        }
      })), me = {
        type: "Feature",
        properties: {
          bufferType: "center"
        },
        geometry: {
          type: "Point",
          coordinates: e ? [...e.geometry.coordinates] : [0, 0]
        }
      }, pe = {
        type: "Feature",
        properties: {
          bufferType: "counter",
          text: o.formatter ? o.formatter(M) : `${M} km2`
        },
        geometry: {
          type: "Point",
          coordinates: v
        }
      };
      return {
        polygonMain: F,
        polygonCenter: me,
        resizers: ye,
        closeButton: fe,
        counter: pe
      };
    }, ae = ({
      polygonMain: e,
      polygonCenter: n,
      resizers: l,
      closeButton: f,
      counter: v
    }) => {
      t.getSource(i) ? t.getSource(i).setData(
        {
          type: "FeatureCollection",
          features: [
            e,
            n,
            ...l,
            f,
            v
          ]
        }
      ) : (t.addSource(i, {
        type: "geojson",
        data: {
          type: "FeatureCollection",
          features: [
            e,
            n,
            ...l,
            f,
            v
          ]
        }
      }), t.addLayer({
        id: a.POLYGON_BORDER,
        type: "line",
        source: i,
        paint: {
          "line-color": o.borderColor,
          "line-opacity": o.borderOpacity,
          "line-width": o.borderWidth,
          "line-offset": 3
        },
        layout: {
          visibility: y()
        },
        filter: ["==", "bufferType", "main"],
        metadata: { mbLayerId: o.id }
      }), t.addLayer({
        id: a.POLYGON_BACKGROUND,
        type: "fill",
        source: i,
        paint: {
          "fill-color": o.backgroundColor,
          "fill-opacity": o.backgroundOpacity
        },
        layout: {
          visibility: y()
        },
        filter: ["==", "bufferType", "main"],
        metadata: { mbLayerId: o.id }
      }), t.addLayer({
        id: a.RESIZER,
        type: "symbol",
        source: i,
        layout: {
          visibility: y(o.resizable),
          "icon-image": "BufferPolygonResizerSVG",
          "icon-size": 1,
          "icon-offset": ["get", "offset"],
          "icon-allow-overlap": !0
        },
        filter: ["==", "bufferType", "resizer"],
        metadata: { mbLayerId: o.id }
      }), t.addLayer({
        id: a.CENTER_POINT,
        type: "symbol",
        source: i,
        layout: {
          visibility: y(),
          "icon-image": "BufferPolygonCenterSVG",
          "icon-size": 1,
          "icon-allow-overlap": !0
        },
        filter: ["==", "bufferType", "center"],
        metadata: { mbLayerId: o.id }
      }), t.addLayer({
        id: a.CLOSE_BUTTON,
        type: "symbol",
        source: i,
        layout: {
          visibility: y(o.closable),
          "icon-image": _,
          "icon-size": o.closeSize,
          "icon-offset": o.closeOffset,
          "icon-allow-overlap": !0
        },
        filter: ["==", "bufferType", "close"],
        metadata: { mbLayerId: o.id }
      }), t.addLayer({
        id: a.DISTANCE_COUNTER,
        type: "symbol",
        source: i,
        paint: {
          "text-color": o.textColor
        },
        layout: {
          visibility: y(o.countable),
          "text-font": o.textFonts,
          "text-size": o.textSize,
          "text-field": ["get", "text"],
          "text-allow-overlap": !0,
          "text-offset": [3.5, 0]
        },
        filter: ["==", "bufferType", "counter"],
        metadata: { mbLayerId: o.id }
      }));
    }, h = () => {
      window.requestAnimationFrame(() => {
        ae(ne());
      });
    }, O = () => {
      h();
    }, le = () => {
      t = G(), s = t.getCanvasContainer(), Z(), X(), O();
    }, { getMapboxInstance: G } = Te(le);
    xe(G, a, o), A(
      () => o.polygon,
      (e) => {
        r.value = K(JSON.parse(JSON.stringify(e))), h();
      },
      {
        deep: !0
      }
    ), A(
      () => o.visible,
      () => {
        H();
      }
    );
    const se = () => {
      ie(), ue(), ce(), W(), t = null;
    }, ie = () => {
      Object.keys(a).forEach((e) => {
        t.getLayer(a[e]) && t.removeLayer(a[e]);
      });
    }, ue = () => {
      t.removeSource(i);
    }, ce = () => {
      C.value.forEach((e) => {
        t.hasImage(e.name) && t.removeImage(e.name);
      });
    };
    return de(() => {
      se();
    }), (e, n) => (ve(), Le(be(_e), {
      images: C.value,
      class: "mb-buffer-polygon-layer"
    }, null, 8, ["images"]));
  }
});
export {
  He as default
};
