import { defineComponent as be, ref as Re, watch as T, onBeforeUnmount as Le, openBlock as Ee, createBlock as Ce, unref as Se } from "vue";
import * as z from "@turf/helpers";
import Te from "@turf/area";
import Oe from "@turf/sector";
import Z from "@turf/distance";
import O from "@turf/destination";
import V from "@turf/bearing";
import { bufferImages as ve, BUFFER_LAYER_ADDITIONAL as Ie, bufferTuffOptions as b } from "../../buffer-layer/src/constants.mjs";
import { useBufferLayer as _e } from "../../buffer-layer/src/use-buffer-layer.mjs";
import { handleCloseImage as Ae, generateDotImage as B } from "../../buffer-layer/src/utils.mjs";
import { MbImageLoader as ze } from "../../image-loader/index.mjs";
import { bufferSectorLayerProps as Be, bufferSectorLayerEmits as he } from "./buffer-sector-layer.mjs";
import { usePropsWatcher as Fe } from "./use-buffer-sector.mjs";
import { createBufferSectorLayer as De, BUFFER_SECTOR_RESIZER_OPTIONS as W, getResizerCursor as h, calcMidPoint as Pe } from "./utils.mjs";
import { useMapCreated as Ue } from "../../map/src/use-map.mjs";
const xe = {
  name: "MbBufferSectorLayer"
}, Je = be({
  ...xe,
  props: Be,
  emits: he,
  setup(Y, { emit: j }) {
    const t = Y, d = j, { getVisibility: f } = _e(t), F = "sector-close", A = Re(
      Ae(ve(F), t.closeIconUrl)
    );
    let m = t.startAngle, y = t.endAngle, i = t.radius, a = [], v = [], o, l, R = !1, L, E = !1, C = !1, p = "";
    const { BUFFER_SECTOR_LAYER: r, BUFFER_SECTOR_SOURCE: c } = De(), q = () => {
      A.value.push(
        B(
          "BufferSectorCenterSVG",
          t.centerColor,
          t.centerRadius
        ),
        B(
          "BufferSectorResizerSVG",
          t.resizerColor,
          t.resizerRadius
        ),
        B(
          "BufferSectorRotaterSVG",
          t.rotaterColor,
          t.resizerRadius
        )
      );
    }, H = () => {
      Object.keys(r).forEach((e) => {
        o.getLayer(r[e]) && o.setLayoutProperty(
          r[e],
          "visibility",
          f(t[Ie[e]])
        );
      });
    }, n = (e, s, u) => {
      typeof s == "string" ? (o.on(e, s, u), v.push({
        event: e,
        target: s,
        handler: u
      })) : (o.on(e, s), v.push({
        event: e,
        handler: s
      }));
    }, $ = () => {
      v.forEach((e) => {
        e.target ? o.off(
          e.event,
          e.target,
          e.handler
        ) : o.off(e.event, e.handler);
      }), v = [];
    }, J = () => {
      n(
        "mouseenter",
        r.SECTOR_BACKGROUND,
        D
      ), n(
        "mouseleave",
        r.SECTOR_BACKGROUND,
        Q
      ), n("mousedown", r.SECTOR_BACKGROUND, ee), n("mouseenter", r.RESIZER, P), n("mouseleave", r.RESIZER, U), n("mousedown", r.RESIZER, x), n("mouseenter", r.ROTATER, P), n("mouseleave", r.ROTATER, U), n("mousedown", r.ROTATER, x), n("click", r.CLOSE_BUTTON, (e) => {
        d("close", e);
      });
    }, D = () => {
      l.style.cursor = "move", R = !0, o.dragPan.disable(), d("mouseenter");
    }, Q = () => {
      l.style.cursor = "", R = !1, o.dragPan.enable(), d("mouseleave");
    }, P = (e) => {
      p = e.features[0].properties.name, l.style.cursor = h(p), R = !0, o.dragPan.disable(), d("mouseenter");
    }, U = (e) => {
      Z(
        [e.lngLat.lng, e.lngLat.lat],
        a
      ) > i ? (l.style.cursor = "", R = !1, o.dragPan.enable(), d("mouseleave")) : D();
    }, x = (e) => {
      R && (L = e.lngLat, E = !0, C = !1, l.style.cursor = h(p), n("mousemove", w), o.once("mouseup", X));
    }, w = (e) => {
      if (E)
        if (l.style.cursor = h(p), p === "Resizer") {
          const s = Z(
            z.point(a),
            z.point([e.lngLat.lng, e.lngLat.lat]),
            b
          );
          i = Math.abs(s), g(a);
        } else
          p === "sectorStartAngle" ? y = V(a, [e.lngLat.lng, e.lngLat.lat]) : p === "sectorEndAngle" && (m = V(a, [e.lngLat.lng, e.lngLat.lat])), L = { lng: e.lngLat.lng, lat: e.lngLat.lat }, g(a);
    }, X = () => {
      E && (l.style.cursor = "", E = !1, d("update", {
        center: a,
        radius: i,
        startAngle: y,
        endAngle: m
      }), o.off("mousemove", w));
    }, ee = (e) => {
      !R || !t.draggable || (L = e.lngLat, C = !0, E = !1, l.style.cursor = "grab", n("mousemove", M), o.once("mouseup", te));
    }, M = (e) => {
      if (!C) return;
      l.style.cursor = "grabbing";
      const s = e.lngLat.lng - L.lng, u = e.lngLat.lat - L.lat;
      L = { lng: e.lngLat.lng, lat: e.lngLat.lat }, N([a[0] + s, a[1] + u]);
    }, te = () => {
      C && (l.style.cursor = "", C = !1, o.off(
        "mousemove",
        r.SECTOR_BACKGROUND,
        M
      ), d("update", {
        center: a,
        radius: i,
        startAngle: y,
        endAngle: m
      }));
    }, oe = (e) => {
      const s = z.point([...e]), u = Pe(y, m), S = Oe(
        s,
        i,
        y,
        m,
        { ...b, properties: { bufferType: "main" } }
      ), I = O(
        s,
        i,
        u,
        b
      ), _ = O(
        s,
        i,
        y,
        b
      ), ce = O(
        s,
        i,
        m,
        b
      ), ue = O(s, 0, 0, b).geometry.coordinates, fe = O(
        s,
        i,
        m,
        b
      ).geometry.coordinates, k = (Te(S) / 1e3 / 1e3).toFixed(2), me = {
        type: "Feature",
        properties: {
          bufferType: "close"
        },
        geometry: {
          type: "Point",
          coordinates: ue
        }
      }, de = Object.entries({
        1: _,
        2: ce
      }).map((K) => ({
        type: "Feature",
        properties: {
          bufferType: "rotater",
          ...W[+K[0]]
        },
        geometry: {
          type: "Point",
          coordinates: [...K[1].geometry.coordinates]
        }
      })), ye = {
        type: "Feature",
        properties: {
          bufferType: "resizer",
          ...W[0]
        },
        geometry: {
          type: "Point",
          coordinates: [...I.geometry.coordinates]
        }
      }, pe = {
        type: "Feature",
        properties: {
          bufferType: "center"
        },
        geometry: {
          type: "Point",
          coordinates: e
        }
      }, ge = {
        type: "Feature",
        properties: {
          bufferType: "counter",
          text: t.formatter ? t.formatter(k, i) : `${k} km2`
        },
        geometry: {
          type: "Point",
          coordinates: fe
        }
      };
      return {
        sectorMain: S,
        sectorCenter: pe,
        sectorResizer: ye,
        sectorRotater: de,
        closeButton: me,
        counter: ge
      };
    }, re = ({
      sectorMain: e,
      sectorCenter: s,
      sectorResizer: u,
      sectorRotater: S,
      closeButton: I,
      counter: _
    }) => {
      o.getSource(c) ? o.getSource(c).setData({
        type: "FeatureCollection",
        features: [
          e,
          s,
          ...S,
          u,
          I,
          _
        ]
      }) : (o.addSource(c, {
        type: "geojson",
        data: {
          type: "FeatureCollection",
          features: [
            e,
            s,
            ...S,
            u,
            I,
            _
          ]
        }
      }), o.addLayer({
        id: r.SECTOR_BORDER,
        type: "line",
        source: c,
        paint: {
          "line-color": t.borderColor,
          "line-opacity": t.borderOpacity,
          "line-width": t.borderWidth,
          "line-offset": 3
        },
        layout: {
          visibility: f()
        },
        filter: ["==", "bufferType", "main"],
        metadata: { mbLayerId: t.id }
      }), o.addLayer({
        id: r.SECTOR_BACKGROUND,
        type: "fill",
        source: c,
        paint: {
          "fill-color": t.backgroundColor,
          "fill-opacity": t.backgroundOpacity
        },
        layout: {
          visibility: f()
        },
        filter: ["==", "bufferType", "main"],
        metadata: { mbLayerId: t.id }
      }), o.addLayer({
        id: r.RESIZER,
        type: "symbol",
        source: c,
        layout: {
          visibility: f(t.resizable),
          "icon-image": ["get", "icon"],
          "icon-size": 1,
          "icon-offset": ["get", "offset"],
          "icon-allow-overlap": !0
        },
        filter: ["==", "bufferType", "resizer"],
        metadata: { mbLayerId: t.id }
      }), o.addLayer({
        id: r.ROTATER,
        type: "symbol",
        source: c,
        layout: {
          visibility: f(t.rotatable),
          "icon-image": ["get", "icon"],
          "icon-size": 1,
          "icon-offset": ["get", "offset"],
          "icon-allow-overlap": !0
        },
        filter: ["==", "bufferType", "rotater"],
        metadata: { mbLayerId: t.id }
      }), o.addLayer({
        id: r.CENTER_POINT,
        type: "symbol",
        source: c,
        layout: {
          visibility: f(),
          "icon-image": "BufferSectorCenterSVG",
          "icon-size": 1,
          "icon-allow-overlap": !0
        },
        filter: ["==", "bufferType", "center"],
        metadata: { mbLayerId: t.id }
      }), o.addLayer({
        id: r.CLOSE_BUTTON,
        type: "symbol",
        source: c,
        layout: {
          visibility: f(t.closable),
          "icon-image": F,
          "icon-size": t.closeSize,
          "icon-offset": t.closeOffset,
          "icon-allow-overlap": !0
        },
        filter: ["==", "bufferType", "close"],
        metadata: { mbLayerId: t.id }
      }), o.addLayer({
        id: r.DISTANCE_COUNTER,
        type: "symbol",
        source: c,
        paint: {
          "text-color": t.textColor
        },
        layout: {
          visibility: f(t.countable),
          "text-font": t.textFonts,
          "text-size": t.textSize,
          "text-field": ["get", "text"],
          "text-allow-overlap": !0,
          "text-offset": [3.5, 0]
        },
        filter: ["==", "bufferType", "counter"],
        metadata: { mbLayerId: t.id }
      }));
    }, g = (e) => {
      window.requestAnimationFrame(() => {
        re(oe(e));
      });
    }, N = (e) => {
      a = e, g(a);
    }, se = () => {
      o = G(), l = o.getCanvasContainer(), q(), J(), N(t.center);
    }, { getMapboxInstance: G } = Ue(se);
    Fe(G, r, t), T(
      () => t.center,
      (e, s) => {
        (e == null ? void 0 : e.join()) !== (s == null ? void 0 : s.join()) && (a = e, g(a));
      }
    ), T(
      () => t.radius,
      (e) => {
        i = e, g(a);
      }
    ), T(
      () => t.startAngle,
      (e) => {
        y = e, g(a);
      }
    ), T(
      () => t.endAngle,
      (e) => {
        m = e, g(a);
      }
    ), T(
      () => t.visible,
      () => {
        H();
      }
    );
    const ae = () => {
      ne(), ie(), le(), $(), o = null;
    }, ne = () => {
      Object.keys(r).forEach((e) => {
        o.getLayer(r[e]) && o.removeLayer(r[e]);
      });
    }, ie = () => {
      o.removeSource(c);
    }, le = () => {
      A.value.forEach((e) => {
        o.hasImage(e.name) && o.removeImage(e.name);
      });
    };
    return Le(() => {
      ae();
    }), (e, s) => (Ee(), Ce(Se(ze), {
      images: A.value,
      class: "mb-buffer-sector-layer"
    }, null, 8, ["images"]));
  }
});
export {
  Je as default
};
