import type { ExtractPropTypes } from 'vue';
import type BuildingLayer from './building-layer.vue';
export declare const buildingLayerProps: {
    heightInfoField: {
        type: StringConstructor;
        required: boolean;
    };
    magnification: {
        type: NumberConstructor;
        default: number;
    };
    base: {
        type: NumberConstructor;
        default: number;
    };
    color: {
        type: StringConstructor;
        default: string;
    };
    opacity: {
        type: NumberConstructor;
        default: number;
    };
    sideGradient: {
        type: BooleanConstructor;
        default: boolean;
    };
    id: {
        type: StringConstructor;
        default: () => string;
    };
    beforeId: StringConstructor;
    maxzoom: {
        type: NumberConstructor;
        default: number;
    };
    minzoom: {
        type: NumberConstructor;
        default: number;
    };
    show: {
        type: BooleanConstructor;
        default: boolean;
    };
    sourceId: StringConstructor;
    sourceLayerName: StringConstructor;
    geoJsonDataSource: import("vue").PropType<string | import("mapbox-gl").GeoJSONSource>;
    data: import("vue").PropType<import("../..").VectorLayerData | import("../..").SymbolLayerData>;
    pickable: {
        type: BooleanConstructor;
        default: boolean;
    };
    useExpression: BooleanConstructor;
    bufferSize: {
        type: NumberConstructor;
        default: number;
    };
    generateId: BooleanConstructor;
    autoHighlight: BooleanConstructor;
    highlightColor: {
        type: import("vue").PropType<string | number[]>;
        default: () => number[];
    };
    cluster: BooleanConstructor;
    clusterRadius: NumberConstructor;
    clusterMinPoints: NumberConstructor;
    clusterMaxZoom: NumberConstructor;
};
export type BuildingLayerProps = ExtractPropTypes<typeof buildingLayerProps>;
export declare const buildingLayerEmits: {
    created: () => boolean;
    click: ({ pixel, mouseCoordinates, coordinates, properties, originalEvent, }: {
        pixel: number[];
        mouseCoordinates: number[];
        coordinates: number[];
        properties: Record<string, any> | null;
        originalEvent: MouseEvent;
    }) => boolean;
    mousemove: ({ pixel, mouseCoordinates, coordinates, properties, originalEvent, }: {
        pixel: number[];
        mouseCoordinates: number[];
        coordinates: number[];
        properties: Record<string, any> | null;
        originalEvent: MouseEvent;
    }) => boolean;
    mouseleave: (event: import("mapbox-gl").MapMouseEvent) => boolean;
};
export type BuildingLayerEmits = typeof buildingLayerEmits;
export type BuildingLayerInstance = InstanceType<typeof BuildingLayer>;
