import type { ExtractPropTypes, PropType } from 'vue';
import type DrawControl from './draw-control.vue';
import type { AnyArr } from '@mapbox-vue3/core/es/common';
export declare const drawControlProps: {
    /**
     * @values 'point','polyline','polygon','trash'
     */
    functions: {
        type: PropType<string[]>;
        default: () => string[];
    };
    /**
     * @values 'top-left' ， 'top-right' ， 'bottom-left' ，'bottom-right'
     */
    position: {
        type: PropType<"top-right" | "top-left" | "bottom-right" | "bottom-left">;
        default: string;
    };
};
export type DrawControlProps = ExtractPropTypes<typeof drawControlProps>;
export declare const drawControlEmits: {
    created: () => boolean;
    'draw.created': (features: AnyArr) => boolean;
    'draw.delete': (features: AnyArr) => boolean;
    'draw.update': ({ action, features }: {
        action: string;
        features: AnyArr;
    }) => boolean;
};
export type DrawControlEmits = typeof drawControlEmits;
export type DrawControlInstance = InstanceType<typeof DrawControl>;
