import { defineComponent as z, computed as m, openBlock as s, createBlock as p, unref as o, withCtx as A, createCommentVNode as g } from "vue";
import { MbLayer as L } from "../../layer/index.mjs";
import { MbSource as C } from "../../source/index.mjs";
import { useVectorLayer as v } from "../../vector-layer/src/use-vector-layer.mjs";
import { heatmapLayerProps as w, heatmapLayerEmits as I } from "./heatmap-layer.mjs";
const k = {
  name: "MbHeatmapLayer"
}, H = z({
  ...k,
  props: w,
  emits: I,
  setup(l, { expose: u }) {
    const a = l, c = m(() => ({
      visibility: a.show ? "visible" : "none"
    })), y = m(() => {
      const { radius: e, weight: r, intensity: t, color: b, opacity: i } = a;
      return {
        "heatmap-radius": Array.isArray(e) ? ["interpolate", ["linear"], ["zoom"], ...e] : e,
        "heatmap-weight": Array.isArray(r) ? ["interpolate", ["linear"], ["get", r[0]], ...r.slice(1)] : r,
        "heatmap-intensity": Array.isArray(t) ? ["interpolate", ["linear"], ["zoom"], ...t] : t,
        "heatmap-opacity": Array.isArray(i) ? ["interpolate", ["linear"], ["zoom"], ...i] : i,
        "heatmap-color": ["interpolate", ["linear"], ["heatmap-density"], ...b]
      };
    }), { sourceIdInternal: n, geoJsonSource: d, createdHandler: h, exportToGeoJson: f } = v(a, { geoType: "point" });
    return u({
      exportToGeoJson: f
    }), (e, r) => (s(), p(o(L), {
      id: e.id,
      "before-id": e.beforeId,
      "source-id": o(n),
      "source-layer": e.sourceLayerName,
      type: "heatmap",
      layout: c.value,
      paint: y.value,
      maxzoom: e.maxzoom,
      minzoom: e.minzoom,
      class: "mb-heatmap-layer",
      onCreated: o(h)
    }, {
      default: A(() => [
        e.sourceId ? g("", !0) : (s(), p(o(C), {
          key: 0,
          id: o(n),
          "geo-json-source": o(d)
        }, null, 8, ["id", "geo-json-source"]))
      ]),
      _: 1
    }, 8, ["id", "before-id", "source-id", "source-layer", "layout", "paint", "maxzoom", "minzoom", "onCreated"]));
  }
});
export {
  H as default
};
