import { v4 as t } from "uuid";
const r = {
  /**
   * 图层id,默认为随机uuid
   * Layer id, default is random uuid
   */
  id: {
    type: String,
    default: () => t()
  },
  /**
   * 图层类型 Layer Type
   * @values symbol line fill circle raster fill-extrusion background heatmap
   */
  type: {
    type: String,
    default: "symbol"
  },
  /**
   * 源数据过滤条件
   * Source data filter conditions
   */
  filter: {
    type: Array
  },
  /**
   * mapbox layout object
   * @see {@link https://www.mapbox.com/mapbox-gl-style-spec/#layer-layout}
   */
  layout: {
    type: Object,
    default: () => ({})
  },
  /**
   * mapbox paint object
   * @see {@link https://www.mapbox.com/mapbox-gl-style-spec/#layer-paint}
   */
  paint: {
    type: Object,
    default: () => ({})
  },
  /**
   * 已创建source的id
   * The id of the created source
   */
  sourceId: String,
  /**
   * 获取源数据的图层名称
   * Get the layer name of the source data
   */
  sourceLayer: String,
  minzoom: {
    type: Number,
    default: 0
  },
  maxzoom: {
    type: Number,
    default: 22
  },
  metadata: {
    type: Object
  },
  /**
   * 用来插入新图层的现有图层 ID
   * The ID of an existing layer into which to insert the new layer
   */
  beforeId: String
};
export {
  r as layerProps
};
