const o = {
  /**
   * 鼠标在地图缩放级别变化时是否自动关闭气泡弹窗
   * Whether to automatically close the bubble pop-up window when the mouse changes the map zoom level
   */
  hideOnZoom: {
    type: Boolean,
    default: !1
  },
  /**
   * 鼠标在地图移动时是否自动关闭气泡弹窗
   * Whether to automatically close the bubble pop-up window when the mouse moves on the map
   */
  hideOnMove: {
    type: Boolean,
    default: !1
  },
  /**
   * 点击地图时是否自动关闭气泡弹窗
   * Whether to automatically close the bubble pop-up window when clicking the map
   */
  hideOnClick: {
    type: Boolean,
    default: !1
  },
  /**
   * @values 'top', 'bottom', 'left', 'right', 'top-left', 'top-right', 'bottom-left', 'bottom-right'
   */
  anchor: {
    type: String,
    validator(t) {
      return typeof t == "string" && [
        "top",
        "bottom",
        "left",
        "right",
        "top-left",
        "top-right",
        "bottom-left",
        "bottom-right"
      ].includes(t);
    },
    default: void 0
  },
  /**
   * popup偏移量  正向为右/下
   * Popup offset, positive direction is right/bottom
   */
  offset: {
    type: [Number, Array],
    default: () => [0, 0]
  },
  /**
   * 添加到popup dom元素上的Class
   * Class added to the popup DOM element
   */
  className: String,
  coordinates: {
    type: Array
  },
  show: {
    type: Boolean,
    default: !0
  },
  /**
   * 是否自动添加气泡指向三角形
   * Whether to automatically add bubble pointing triangle
   */
  showTip: {
    type: Boolean,
    default: !0
  },
  tipColor: {
    type: String,
    default: "#fff"
  }
}, a = {
  "update:show": (t) => typeof t == "boolean"
};
export {
  a as mapPopupEmits,
  o as mapPopupProps
};
