import { defineComponent as A, ref as k, watch as C, onBeforeUnmount as B, openBlock as $, createElementBlock as O, normalizeClass as D, normalizeStyle as E, createCommentVNode as j, renderSlot as M, createElementVNode as _ } from "vue";
import e from "@mapbox/point-geometry";
import { mapPopupProps as S, mapPopupEmits as T } from "./map-popup.mjs";
import { useMapCreated as V } from "../../map/src/use-map.mjs";
const Z = {
  key: 0,
  class: "mb-map-popup-tip"
}, q = { class: "mb-map-popup-content" }, H = {
  name: "MbMapPopup"
}, G = A({
  ...H,
  props: S,
  emits: T,
  setup(P, { emit: z }) {
    const u = {
      center: "translate(-50%,-50%)",
      top: "translate(-50%,0)",
      "top-left": "translate(0,0)",
      "top-right": "translate(-100%,0)",
      bottom: "translate(-50%,-100%)",
      "bottom-left": "translate(0,-100%)",
      "bottom-right": "translate(-100%,-100%)",
      left: "translate(0,-50%)",
      right: "translate(-100%,-50%)"
    }, n = P, L = z, a = k(), p = k(n.show), i = () => {
      const t = h();
      if (!t || !p.value || !a.value) return;
      let o = n.anchor;
      const r = t.project(n.coordinates), c = f(n.offset);
      if (!o) {
        const w = a.value.offsetWidth, y = a.value.offsetHeight;
        let s;
        r.y + c.bottom.y < y ? s = ["top"] : r.y > t.transform.height - y ? s = ["bottom"] : s = [], r.x < w / 2 ? s.push("left") : r.x > t.transform.width - w / 2 && s.push("right"), s.length === 0 ? o = "bottom" : o = s.join("-");
      }
      const g = r.add(c[o]).round();
      a.value.style.transform = `${u[o]} translate(${g.x}px,${g.y}px)`, N(a.value, o);
    }, l = () => {
      p.value = !1, L("update:show", !1);
    }, v = () => {
      n.hideOnClick && l();
    }, d = () => {
      n.hideOnZoom && l();
    }, b = () => {
      n.hideOnMove && l();
    }, m = () => {
      const t = h();
      t && (t.off("move", i), t.on("move", b), t.on("zoomstart", d), t.on("click", v), t.off("remove", m));
    }, f = (t) => {
      if (t)
        if (typeof t == "number") {
          const o = Math.round(Math.sqrt(0.5 * t ** 2));
          return {
            center: new e(0, 0),
            top: new e(0, t),
            "top-left": new e(o, o),
            "top-right": new e(-o, o),
            bottom: new e(0, -t),
            "bottom-left": new e(o, -o),
            "bottom-right": new e(-o, -o),
            left: new e(t, 0),
            right: new e(-t, 0)
          };
        } else if (t instanceof e || Array.isArray(t)) {
          const o = e.convert(t);
          return {
            center: o,
            top: o,
            "top-left": o,
            "top-right": o,
            bottom: o,
            "bottom-left": o,
            "bottom-right": o,
            left: o,
            right: o
          };
        } else
          return {
            center: e.convert(t.center || [0, 0]),
            top: e.convert(t.top || [0, 0]),
            "top-left": e.convert(t["top-left"] || [0, 0]),
            "top-right": e.convert(t["top-right"] || [0, 0]),
            bottom: e.convert(t.bottom || [0, 0]),
            "bottom-left": e.convert(t["bottom-left"] || [0, 0]),
            "bottom-right": e.convert(t["bottom-right"] || [0, 0]),
            left: e.convert(t.left || [0, 0]),
            right: e.convert(t.right || [0, 0])
          };
      else return f(new e(0, 0));
    }, N = (t, o) => {
      const r = t.classList;
      for (const c in u)
        r.remove(`mb-map-popup-anchor-${c}`);
      r.add(`mb-map-popup-anchor-${o}`);
    }, x = () => {
      const t = h();
      i(), t.on("move", i), t.on("move", b), t.on("zoomstart", d), t.on("click", v), t.on("remove", m);
    }, { getMapboxInstance: h } = V(x);
    return C(
      () => n.coordinates,
      () => {
        i();
      }
    ), C(
      () => n.show,
      (t) => {
        p.value = t, i();
      }
    ), B(() => {
      m();
    }), (t, o) => ($(), O("div", {
      ref_key: "popupDiv",
      ref: a,
      class: D(["mb-map-popup", t.className ? "" : t.className]),
      style: E({
        "--tip-color": t.tipColor,
        visibility: p.value ? "visible" : "hidden"
      })
    }, [
      t.showTip ? ($(), O("div", Z)) : j("", !0),
      M(t.$slots, "default", {}, () => [
        _("div", q, [
          _("button", {
            class: "mb-map-popup-close-button",
            type: "button",
            onClick: l
          }, " × "),
          M(t.$slots, "content")
        ])
      ])
    ], 6));
  }
});
export {
  G as default
};
