import { defineComponent as ae, ref as x, watch as b, provide as se, onMounted as ie, onUnmounted as ce, openBlock as le, createElementBlock as de, createElementVNode as me, renderSlot as pe, nextTick as ue } from "vue";
import { v4 as ge } from "uuid";
import { mapboxgl as y } from "@mapbox-web/supermap";
import { mapContextKey as fe } from "./constants.mjs";
import { mapProps as be, mapEmits as ye } from "./map.mjs";
const he = ["id"], ve = {
  name: "MbMap"
}, ke = ae({
  ...ve,
  props: be,
  emits: ye,
  setup(M, { expose: P, emit: Z }) {
    y.config.REQUIRE_ACCESS_TOKEN = !1;
    const p = M, c = Z, z = x(), A = x(0), L = x(ge().replace(/-/gi, ""));
    let t, j;
    const F = new Promise((e, o) => {
      j = { resolve: e, reject: o };
    }), N = (e, o) => {
      t.addSource(e, o);
    }, R = (e) => t.getSource(e), K = (e, o) => {
      t.addLayer(e, o);
    }, W = (e, o) => {
      !t || e === o || t.moveLayer(e, o);
    }, C = () => t.getZoom(), k = (e) => {
      e !== C() && t.setZoom(e);
    }, h = () => {
      const e = t.getCenter();
      return [e.lng, e.lat];
    }, D = () => {
      t.resize();
    }, U = (e) => {
      const i = t.getStyle().layers.map((n) => ({
        id: n.id,
        metadata: n.metadata || {},
        deleted: !1
      })), d = {};
      e.forEach((n) => {
        d[n] = [], i.forEach((s, l) => {
          (s.metadata.mbLayerId === n || s.id === n) && d[n].push(l);
        });
      });
      const u = [...e];
      u.sort((n, s) => d[n][0] - d[s][0]);
      const a = {}, g = {};
      for (const [n, s] of e.entries()) {
        const l = u[n];
        a[l] = [], g[s] = [], i.forEach((r) => {
          (r.metadata.mbLayerId === l || r.id === l) && a[l].push(r.id), (r.metadata.mbLayerId === s || r.id === s) && g[s].push({ ...r, new: !0 });
        });
      }
      for (const [n, s] of e.entries()) {
        const l = u[n];
        let r = -1;
        for (const [v, f] of i.entries())
          f.new || a[l].includes(f.id) && (r === -1 && (r = v), f.deleted = !0);
        i.splice(r, 0, ...g[s]);
      }
      const m = i.filter((n) => !n.deleted);
      for (let n = m.length - 1; n >= 0; n--)
        t.moveLayer(
          m[n].id,
          m[n + 1] ? m[n + 1].id : void 0
        );
    }, w = (e) => {
      const o = h();
      !e || !o || e[0] === o[0] && e[1] === o[1] || t.setCenter(e);
    }, S = () => t.getBearing(), B = (e) => {
      e !== S() && t.setBearing(e);
    }, T = () => t.getPitch(), _ = (e) => {
      e !== T() && t.setPitch(e);
    }, J = (e) => {
      t.jumpTo(e);
    }, Q = (e) => (e.duration || (e.duration = 1e3), t.easeTo(e), new Promise((o) => {
      t.once("moveend", () => {
        o();
      });
    })), $ = (e) => (t.flyTo(e), new Promise((o) => {
      t.once("moveend", () => {
        o();
      });
    })), q = () => {
      t.stop();
    }, G = (e, o) => t.cameraForBounds(e, o), H = (e, o) => (t.fitBounds(e, o), new Promise((i) => {
      t.once("moveend", () => {
        i();
      });
    })), X = (e) => t.project(e), Y = () => {
      t.on("idle", () => {
        A.value++;
      }), t.on("zoomend", () => {
        c("update:zoom", t.getZoom());
      }), t.on("moveend", () => {
        c("update:center", h());
      }), t.on("rotateend", () => {
        c("update:bearing", t.getBearing());
      }), t.on("pitchend", () => {
        c("update:pitch", t.getPitch());
      });
      let e;
      t.on("click", (o) => {
        o.originalEvent.cancelBubble || (c("click", {
          originalEvent: o.originalEvent,
          pixel: Object.values(o.point),
          coordinates: Object.values(o.lngLat.wrap())
        }), e !== void 0 ? (clearTimeout(e), e = void 0, c("dblclick", {
          originalEvent: o.originalEvent,
          pixel: Object.values(o.point),
          coordinates: Object.values(o.lngLat.wrap())
        })) : e = setTimeout(() => {
          e = void 0, c("singleclick", {
            originalEvent: o.originalEvent,
            pixel: Object.values(o.point),
            coordinates: Object.values(o.lngLat.wrap())
          });
        }, 200), ue(() => {
          o.originalEvent.cancelBubble = !0;
        }));
      }), t.on("mousemove", (o) => {
        c("mousemove", {
          pixel: Object.values(o.point),
          coordinates: Object.values(o.lngLat.wrap()),
          originalEvent: o.originalEvent
        });
      }), t.on("mouseout", (o) => {
        c("mouseout", o);
      });
    };
    b(
      () => p.zoom,
      (e) => {
        k(e);
      }
    ), b(
      () => p.center,
      (e) => {
        w(e);
      }
    ), b(
      () => p.bearing,
      (e) => {
        B(e);
      }
    ), b(
      () => p.pitch,
      (e) => {
        _(e);
      }
    ), se(fe, {
      getMap: F
    });
    const I = {
      addSource: N,
      getSource: R,
      addLayer: K,
      moveLayer: W,
      getZoom: C,
      setZoom: k,
      getCenter: h,
      setCenter: w,
      resize: D,
      reorderLayers: U,
      getBearing: S,
      setBearing: B,
      getPitch: T,
      setPitch: _,
      jumpTo: J,
      easeTo: Q,
      flyTo: $,
      stop: q,
      cameraForBounds: G,
      fitBounds: H,
      project: X
    };
    return ie(() => {
      const {
        glyphs: e,
        sprite: o,
        crs: i,
        zoom: d,
        center: u,
        mapStyle: a,
        bearing: g,
        pitch: m,
        bounds: n,
        maxBounds: s,
        minzoom: l,
        extendProps: r,
        maxzoom: v,
        antialias: f,
        hash: V,
        interactive: ee,
        bearingSnap: te,
        pitchWithRotate: oe,
        clickTolerance: ne,
        attributionControl: re
      } = p, E = {};
      e && (E.glyphs = e), o && (E.sprite = o), typeof a == "object" && !(r != null && r.accessToken) && (a.glyphs && a.glyphs.startsWith("mapbox:") && delete a.glyphs, a.sprite && a.sprite.startsWith("mapbox:") && delete a.sprite);
      const O = Array.isArray(i) ? new y.CRS(...i) : i;
      t = new y.Map(
        Object.assign(
          {
            container: L.value,
            zoom: d,
            center: u,
            style: typeof a == "string" ? a : Object.assign({}, a, E),
            bearing: g,
            pitch: m,
            bounds: n,
            maxBounds: s,
            minZoom: l,
            maxZoom: v,
            antialias: f,
            hash: V,
            interactive: ee,
            bearingSnap: te,
            pitchWithRotate: oe,
            clickTolerance: ne,
            attributionControl: re,
            localIdeographFontFamily: "'Noto Sans', 'Noto Sans CJK SC', sans-serif",
            doubleClickZoom: !1
          },
          O ? { crs: O } : {},
          r
        )
      ), Y(), t.on("load", () => {
        j.resolve({
          mapboxInstance: t,
          mapInstance: I
        }), c("created", t);
      }), t.mapboxgl = y;
    }), ce(() => {
      t.mapboxgl = null, t.remove(), t = null;
    }), P(I), (e, o) => (le(), de("div", {
      ref_key: "container",
      ref: z,
      class: "mb-map-container"
    }, [
      me("div", {
        id: L.value,
        style: { width: "100%", height: "100%" }
      }, null, 8, he),
      pe(e.$slots, "default")
    ], 512));
  }
});
export {
  ke as default
};
