import type { ExtractPropTypes, PropType } from 'vue';
import type NavigationControl from './navigation-control.vue';
export declare const navigationControlProps: {
    /**
     * 是否显示指南针
     * Whether to display the compass
     */
    showCompass: {
        type: BooleanConstructor;
        default: boolean;
    };
    /**
     * 是否显示放大缩小按钮
     * Whether to display the zoom in and zoom out buttons
     */
    showZoom: {
        type: BooleanConstructor;
        default: boolean;
    };
    /**
     * @values 'top-left' ， 'top-right' ， 'bottom-left' ，'bottom-right'
     */
    position: {
        type: PropType<"top-right" | "top-left" | "bottom-right" | "bottom-left">;
        default: string;
    };
};
export type NavigationControlProps = ExtractPropTypes<typeof navigationControlProps>;
export declare const navigationControlEmits: {};
export type NavigationControlEmits = typeof navigationControlEmits;
export type NavigationControlInstance = InstanceType<typeof NavigationControl>;
