import { vectorLayerProps as t, vectorLayerEmits as e } from "../../vector-layer/src/vector-layer.mjs";
const a = {
  ...t,
  /**
   * @values 'butt' 'round' 'square'
   */
  lineCap: {
    type: String,
    default: "butt"
  },
  /**
   * @values 'bevel' 'round' 'miter'
   */
  lineJoin: {
    type: String,
    default: "miter"
  },
  opacity: {
    type: Number,
    default: 1
  },
  /**
   * 颜色值
   * 支持 '#000000' 'rgb(0,0,0)' [255,0,0,1]等模式
   */
  /**
   * Color value
   * Supports modes such as '#000000' 'rgb(0,0,0)'
   */
  color: {
    type: [String, Array],
    default: "#000000"
  },
  /**
   * 宽度，以像素值为单位
   * Width, in pixels
   */
  width: {
    type: [Number, Array],
    default: 1
  },
  /**
   * 偏移量，正数表示 右/下
   * Offset, positive number means right/bottom
   */
  translate: {
    type: Array,
    default: () => [0, 0]
  },
  /**
   * 形成虚线的 实线段与间隙的长度。以线宽为单位
   * The length of the solid line segments and gaps that form the dashed line. In units of line width
   */
  dashArray: Array,
  offset: {
    type: Number,
    default: 0
  },
  blur: {
    type: Number,
    default: 0
  }
}, y = e;
export {
  y as polylineLayerEmits,
  a as polylineLayerProps
};
