import type { ExtractPropTypes, PropType } from 'vue';
import type ScaleControl from './scale-control.vue';
export declare const scaleControlProps: {
    /**
     * ScaleControl控件的最大长度，以像素为单位
     * The maximum length of the ScaleControl control, in pixels
     */
    maxWidth: {
        type: NumberConstructor;
        default: number;
    };
    /**
     * 单位 Unit
     * @values 'imperial' ， 'metric' ， 'nautical'
     */
    unit: {
        type: PropType<"imperial" | "metric" | "nautical">;
        default: string;
    };
    /**
     * @values 'top-left' ， 'top-right' ， 'bottom-left' ，'bottom-right'
     */
    position: {
        type: PropType<"top-right" | "top-left" | "bottom-right" | "bottom-left">;
        default: string;
    };
};
export type ScaleControlProps = ExtractPropTypes<typeof scaleControlProps>;
export declare const scaleControlEmits: {};
export type ScaleControlEmits = typeof scaleControlEmits;
export type ScaleControlInstance = InstanceType<typeof ScaleControl>;
