import type { GeoJSONSource, MapMouseEvent } from 'mapbox-gl';
import type { IndexAny } from '@mapbox-vue3/core/es/common';
declare const _default: import("vue").DefineComponent<import("vue").ExtractPropTypes<{
    symbolPlacement: {
        type: StringConstructor;
        default: string;
    };
    symbolSpacing: {
        type: NumberConstructor;
        default: number;
    };
    symbolAvoidEdges: {
        type: BooleanConstructor;
        default: boolean;
    };
    symbolZOrder: {
        type: StringConstructor;
        default: string;
    };
    iconAllowOverlap: {
        type: BooleanConstructor;
        default: boolean;
    };
    iconAnchor: {
        type: StringConstructor;
        default: string;
    };
    iconColor: {
        type: StringConstructor;
        default: string;
    };
    iconImage: {
        type: import("vue").PropType<string | any[]>;
    };
    iconImageField: {
        type: StringConstructor;
    };
    iconSize: {
        type: NumberConstructor;
        default: number;
    };
    iconOffset: {
        type: import("vue").PropType<number[]>;
        default: () => number[];
    };
    iconOpacity: {
        type: NumberConstructor;
        default: number;
    };
    iconOptional: {
        type: BooleanConstructor;
        default: boolean;
    };
    iconRotate: {
        type: import("vue").PropType<number | any[]>;
        default: number;
    };
    iconRotationAlignment: {
        type: StringConstructor;
        default: string;
    };
    iconIgnorePlacement: BooleanConstructor;
    iconTranslate: {
        type: import("vue").PropType<number[]>;
        default: () => number[];
    };
    textAllowOverlap: {
        type: BooleanConstructor;
        default: boolean;
    };
    textAnchor: {
        type: StringConstructor;
        default: string;
    };
    textColor: {
        type: StringConstructor;
        default: string;
    };
    textHaloColor: {
        type: StringConstructor;
        default: string;
    };
    textHaloWidth: {
        type: NumberConstructor;
        default: number;
    };
    textHaloBlur: {
        type: NumberConstructor;
        default: number;
    };
    text: {
        type: StringConstructor;
        default: string;
    };
    textField: {
        type: StringConstructor;
        default: string;
    };
    textFont: {
        type: import("vue").PropType<string[]>;
        default: () => string[];
    };
    textLetterSpacing: {
        type: NumberConstructor;
        default: number;
    };
    textLineHeight: {
        type: NumberConstructor;
        default: number;
    };
    textMaxWidth: {
        type: NumberConstructor;
        default: number;
    };
    textOffset: {
        type: import("vue").PropType<number[]>;
        default: () => number[];
    };
    textOpacity: {
        type: NumberConstructor;
        default: number;
    };
    textOptional: {
        type: BooleanConstructor;
        default: boolean;
    };
    textSize: {
        type: NumberConstructor;
        default: number;
    };
    textTranslate: {
        type: import("vue").PropType<number[]>;
        default: () => number[];
    };
    textTranslateAnchor: {
        type: StringConstructor;
        default: string;
    };
    textPadding: {
        type: NumberConstructor;
        default: number;
    };
    cluster: {
        type: BooleanConstructor;
        default: boolean;
    };
    clusterRadius: {
        type: NumberConstructor;
        default: number;
    };
    clusterMaxZoom: {
        type: NumberConstructor;
        default: number;
    };
    clusterMinPoints: {
        type: NumberConstructor;
        default: number;
    };
    clusterIcons: {
        type: import("vue").PropType<IndexAny[]>;
        default: () => ({
            count: number;
            textColor: string;
            textSize: number;
            functionName: string;
            functionProps: {
                color: string;
                radius: number;
            };
        } | {
            textColor: string;
            textSize: number;
            functionName: string;
            functionProps: {
                radius: number;
                color: string;
            };
            count?: undefined;
        })[];
    };
    clusterIconSize: {
        type: NumberConstructor;
        default: number;
    };
    clusterIconTranslate: {
        type: import("vue").PropType<number[]>;
        default: () => number[];
    };
    clusterIconOffset: {
        type: import("vue").PropType<number[]>;
        default: () => number[];
    };
    clusterIconAnchor: {
        type: StringConstructor;
        default: string;
    };
    spiderify: {
        type: BooleanConstructor;
        default: boolean;
    };
    maxLeafesTospiderify: {
        type: NumberConstructor;
        default: number;
    };
    distanceBetweenSpiderPoints: {
        type: NumberConstructor;
        default: number;
    };
    spiderLegColor: {
        type: StringConstructor;
        default: string;
    };
    spiderLegWidth: {
        type: NumberConstructor;
        default: number;
    };
    comparePrecision: {
        type: NumberConstructor;
        default: number;
    };
    clusterSpiralPoints: {
        type: NumberConstructor;
        default: number;
    };
    id: {
        type: StringConstructor;
        default: () => string;
    };
    beforeId: StringConstructor;
    maxzoom: {
        type: NumberConstructor;
        default: number;
    };
    minzoom: {
        type: NumberConstructor;
        default: number;
    };
    show: {
        type: BooleanConstructor;
        default: boolean;
    };
    sourceId: StringConstructor;
    sourceLayerName: StringConstructor;
    geoJsonDataSource: import("vue").PropType<string | GeoJSONSource>;
    data: import("vue").PropType<import("@mapbox-vue3/core/es/map").VectorLayerData | import("@mapbox-vue3/core/es/map").SymbolLayerData>;
    pickable: {
        type: BooleanConstructor;
        default: boolean;
    };
    useExpression: BooleanConstructor;
    bufferSize: {
        type: NumberConstructor;
        default: number;
    };
    generateId: BooleanConstructor;
    autoHighlight: BooleanConstructor;
    highlightColor: {
        type: import("vue").PropType<string | number[]>;
        default: () => number[];
    };
}>, {
    exportToGeoJson: () => string | null;
}, {}, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {
    created: () => void;
    click: (args_0: {
        pixel: number[];
        mouseCoordinates: number[];
        coordinates: number[];
        properties: Record<string, any> | null;
        originalEvent: MouseEvent;
    }) => void;
    mouseenter: (args_0: {
        pixel: number[];
        mouseCoordinates: number[];
        coordinates: number[];
        properties: IndexAny | null;
        originalEvent: MouseEvent;
    }) => void;
    mouseleave: (event: MapMouseEvent) => void;
    mousemove: (args_0: {
        pixel: number[];
        mouseCoordinates: number[];
        coordinates: number[];
        properties: Record<string, any> | null;
        originalEvent: MouseEvent;
    }) => void;
    clusterclick: (args_0: {
        pixel: number[];
        mouseCoordinates: number[];
        data: {
            coordinates: number[];
            properties: IndexAny;
        }[];
        originalEvent: MouseEvent;
    }) => void;
}, string, import("vue").PublicProps, Readonly<import("vue").ExtractPropTypes<{
    symbolPlacement: {
        type: StringConstructor;
        default: string;
    };
    symbolSpacing: {
        type: NumberConstructor;
        default: number;
    };
    symbolAvoidEdges: {
        type: BooleanConstructor;
        default: boolean;
    };
    symbolZOrder: {
        type: StringConstructor;
        default: string;
    };
    iconAllowOverlap: {
        type: BooleanConstructor;
        default: boolean;
    };
    iconAnchor: {
        type: StringConstructor;
        default: string;
    };
    iconColor: {
        type: StringConstructor;
        default: string;
    };
    iconImage: {
        type: import("vue").PropType<string | any[]>;
    };
    iconImageField: {
        type: StringConstructor;
    };
    iconSize: {
        type: NumberConstructor;
        default: number;
    };
    iconOffset: {
        type: import("vue").PropType<number[]>;
        default: () => number[];
    };
    iconOpacity: {
        type: NumberConstructor;
        default: number;
    };
    iconOptional: {
        type: BooleanConstructor;
        default: boolean;
    };
    iconRotate: {
        type: import("vue").PropType<number | any[]>;
        default: number;
    };
    iconRotationAlignment: {
        type: StringConstructor;
        default: string;
    };
    iconIgnorePlacement: BooleanConstructor;
    iconTranslate: {
        type: import("vue").PropType<number[]>;
        default: () => number[];
    };
    textAllowOverlap: {
        type: BooleanConstructor;
        default: boolean;
    };
    textAnchor: {
        type: StringConstructor;
        default: string;
    };
    textColor: {
        type: StringConstructor;
        default: string;
    };
    textHaloColor: {
        type: StringConstructor;
        default: string;
    };
    textHaloWidth: {
        type: NumberConstructor;
        default: number;
    };
    textHaloBlur: {
        type: NumberConstructor;
        default: number;
    };
    text: {
        type: StringConstructor;
        default: string;
    };
    textField: {
        type: StringConstructor;
        default: string;
    };
    textFont: {
        type: import("vue").PropType<string[]>;
        default: () => string[];
    };
    textLetterSpacing: {
        type: NumberConstructor;
        default: number;
    };
    textLineHeight: {
        type: NumberConstructor;
        default: number;
    };
    textMaxWidth: {
        type: NumberConstructor;
        default: number;
    };
    textOffset: {
        type: import("vue").PropType<number[]>;
        default: () => number[];
    };
    textOpacity: {
        type: NumberConstructor;
        default: number;
    };
    textOptional: {
        type: BooleanConstructor;
        default: boolean;
    };
    textSize: {
        type: NumberConstructor;
        default: number;
    };
    textTranslate: {
        type: import("vue").PropType<number[]>;
        default: () => number[];
    };
    textTranslateAnchor: {
        type: StringConstructor;
        default: string;
    };
    textPadding: {
        type: NumberConstructor;
        default: number;
    };
    cluster: {
        type: BooleanConstructor;
        default: boolean;
    };
    clusterRadius: {
        type: NumberConstructor;
        default: number;
    };
    clusterMaxZoom: {
        type: NumberConstructor;
        default: number;
    };
    clusterMinPoints: {
        type: NumberConstructor;
        default: number;
    };
    clusterIcons: {
        type: import("vue").PropType<IndexAny[]>;
        default: () => ({
            count: number;
            textColor: string;
            textSize: number;
            functionName: string;
            functionProps: {
                color: string;
                radius: number;
            };
        } | {
            textColor: string;
            textSize: number;
            functionName: string;
            functionProps: {
                radius: number;
                color: string;
            };
            count?: undefined;
        })[];
    };
    clusterIconSize: {
        type: NumberConstructor;
        default: number;
    };
    clusterIconTranslate: {
        type: import("vue").PropType<number[]>;
        default: () => number[];
    };
    clusterIconOffset: {
        type: import("vue").PropType<number[]>;
        default: () => number[];
    };
    clusterIconAnchor: {
        type: StringConstructor;
        default: string;
    };
    spiderify: {
        type: BooleanConstructor;
        default: boolean;
    };
    maxLeafesTospiderify: {
        type: NumberConstructor;
        default: number;
    };
    distanceBetweenSpiderPoints: {
        type: NumberConstructor;
        default: number;
    };
    spiderLegColor: {
        type: StringConstructor;
        default: string;
    };
    spiderLegWidth: {
        type: NumberConstructor;
        default: number;
    };
    comparePrecision: {
        type: NumberConstructor;
        default: number;
    };
    clusterSpiralPoints: {
        type: NumberConstructor;
        default: number;
    };
    id: {
        type: StringConstructor;
        default: () => string;
    };
    beforeId: StringConstructor;
    maxzoom: {
        type: NumberConstructor;
        default: number;
    };
    minzoom: {
        type: NumberConstructor;
        default: number;
    };
    show: {
        type: BooleanConstructor;
        default: boolean;
    };
    sourceId: StringConstructor;
    sourceLayerName: StringConstructor;
    geoJsonDataSource: import("vue").PropType<string | GeoJSONSource>;
    data: import("vue").PropType<import("@mapbox-vue3/core/es/map").VectorLayerData | import("@mapbox-vue3/core/es/map").SymbolLayerData>;
    pickable: {
        type: BooleanConstructor;
        default: boolean;
    };
    useExpression: BooleanConstructor;
    bufferSize: {
        type: NumberConstructor;
        default: number;
    };
    generateId: BooleanConstructor;
    autoHighlight: BooleanConstructor;
    highlightColor: {
        type: import("vue").PropType<string | number[]>;
        default: () => number[];
    };
}>> & Readonly<{
    onCreated?: (() => any) | undefined;
    onClick?: ((args_0: {
        pixel: number[];
        mouseCoordinates: number[];
        coordinates: number[];
        properties: Record<string, any> | null;
        originalEvent: MouseEvent;
    }) => any) | undefined;
    onMouseenter?: ((args_0: {
        pixel: number[];
        mouseCoordinates: number[];
        coordinates: number[];
        properties: IndexAny | null;
        originalEvent: MouseEvent;
    }) => any) | undefined;
    onMouseleave?: ((event: MapMouseEvent) => any) | undefined;
    onMousemove?: ((args_0: {
        pixel: number[];
        mouseCoordinates: number[];
        coordinates: number[];
        properties: Record<string, any> | null;
        originalEvent: MouseEvent;
    }) => any) | undefined;
    onClusterclick?: ((args_0: {
        pixel: number[];
        mouseCoordinates: number[];
        data: {
            coordinates: number[];
            properties: IndexAny;
        }[];
        originalEvent: MouseEvent;
    }) => any) | undefined;
}>, {
    minzoom: number;
    maxzoom: number;
    text: string;
    id: string;
    textColor: string;
    textSize: number;
    cluster: boolean;
    clusterRadius: number;
    clusterMaxZoom: number;
    clusterMinPoints: number;
    generateId: boolean;
    show: boolean;
    pickable: boolean;
    useExpression: boolean;
    bufferSize: number;
    autoHighlight: boolean;
    highlightColor: string | number[];
    symbolPlacement: string;
    symbolSpacing: number;
    symbolAvoidEdges: boolean;
    symbolZOrder: string;
    iconAllowOverlap: boolean;
    iconAnchor: string;
    iconColor: string;
    iconSize: number;
    iconOffset: number[];
    iconOpacity: number;
    iconOptional: boolean;
    iconRotate: number | any[];
    iconRotationAlignment: string;
    iconIgnorePlacement: boolean;
    iconTranslate: number[];
    textAllowOverlap: boolean;
    textAnchor: string;
    textHaloColor: string;
    textHaloWidth: number;
    textHaloBlur: number;
    textField: string;
    textFont: string[];
    textLetterSpacing: number;
    textLineHeight: number;
    textMaxWidth: number;
    textOffset: number[];
    textOpacity: number;
    textOptional: boolean;
    textTranslate: number[];
    textTranslateAnchor: string;
    textPadding: number;
    clusterIcons: IndexAny[];
    clusterIconSize: number;
    clusterIconTranslate: number[];
    clusterIconOffset: number[];
    clusterIconAnchor: string;
    spiderify: boolean;
    maxLeafesTospiderify: number;
    distanceBetweenSpiderPoints: number;
    spiderLegColor: string;
    spiderLegWidth: number;
    comparePrecision: number;
    clusterSpiralPoints: number;
}, {}, {}, {}, string, import("vue").ComponentProvideOptions, true, {}, any>;
export default _default;
