import { defineComponent as re, reactive as J, computed as h, watch as S, onBeforeUnmount as ie, openBlock as m, createElementBlock as ne, createBlock as b, unref as n, createCommentVNode as v, createVNode as se } from "vue";
import * as R from "@turf/helpers";
import "csscolorparser-ts";
import { iconGenerator as ae } from "../../common/icon-generator.mjs";
import { MbLayer as P } from "../../layer/index.mjs";
import { MbSource as B } from "../../source/index.mjs";
import { useVectorLayer as le } from "../../vector-layer/src/use-vector-layer.mjs";
import { symbolLayerProps as ce, symbolLayerEmits as ue } from "./symbol-layer.mjs";
import { useMapCreated as pe } from "../../map/src/use-map.mjs";
const de = { class: "mb-symbol-layer" }, me = {
  name: "MbSymbolLayer"
}, Le = re({
  ...me,
  props: ce,
  emits: ue,
  setup(q, { expose: V, emit: W }) {
    const t = q, I = W;
    let M = [];
    const L = J({
      type: "geojson",
      data: {
        type: "FeatureCollection",
        features: []
      }
    }), C = J({
      type: "geojson",
      data: {
        type: "FeatureCollection",
        features: []
      }
    }), A = h(() => {
      const e = {
        "symbol-placement": t.symbolPlacement,
        "symbol-spacing": t.symbolSpacing,
        "symbol-avoid-edges": t.symbolAvoidEdges,
        "symbol-z-order": t.symbolZOrder,
        visibility: ""
      };
      return (t.iconImage || t.iconImageField) && Object.assign(e, {
        "icon-allow-overlap": t.iconAllowOverlap,
        "icon-anchor": t.iconAnchor,
        "icon-image": t.iconImageField ? ["get", t.iconImageField] : t.iconImage,
        "icon-size": t.iconSize,
        "icon-offset": t.iconOffset,
        "icon-optional": t.iconOptional,
        "icon-ignore-placement": t.iconIgnorePlacement,
        "icon-rotate": t.iconRotate,
        "icon-rotation-alignment": t.iconRotationAlignment
      }), (t.textField || t.text) && Object.assign(e, {
        "text-allow-overlap": t.textAllowOverlap,
        "text-anchor": t.textAnchor,
        "text-field": t.useExpression ? t.textField : t.textField ? ["get", t.textField] : t.text,
        "text-font": t.textFont,
        "text-letter-spacing": t.textLetterSpacing,
        "text-line-height": t.textLineHeight,
        "text-max-width": t.textMaxWidth,
        "text-offset": t.textOffset,
        "text-optional": t.textOptional,
        "text-size": t.textSize,
        "text-padding": t.textPadding
      }), e.visibility = t.show ? "visible" : "none", e;
    }), H = h(() => {
      const e = {};
      return t.iconImage && Object.assign(e, {
        "icon-color": t.iconColor,
        "icon-opacity": t.iconOpacity,
        "icon-translate": t.iconTranslate
      }), (t.textField || t.text) && Object.assign(e, {
        "text-color": t.textColor,
        "text-opacity": t.textOpacity,
        "text-translate": t.textTranslate,
        "text-translate-anchor": t.textTranslateAnchor,
        "text-halo-color": t.textHaloColor,
        "text-halo-width": t.textHaloWidth,
        "text-halo-blur": t.textHaloBlur
      }), e;
    }), D = h(() => {
      if (!t.cluster) return;
      const e = {
        "text-field": "{point_count_abbreviated}",
        "text-font": t.textFont,
        "text-size": ["step", ["get", "point_count"]],
        "text-allow-overlap": !0,
        "text-optional": !0,
        "icon-image": ["step", ["get", "point_count"]],
        "icon-allow-overlap": !0,
        "icon-size": t.clusterIconSize,
        "icon-offset": t.clusterIconOffset,
        "icon-anchor": t.clusterIconAnchor,
        visibility: ""
      };
      if (t.clusterIcons.length > 1)
        t.clusterIcons.forEach(
          ({ count: o, iconName: i, functionName: s, textSize: a }, l) => {
            if (i)
              o !== void 0 ? e["icon-image"].push(i, o) : e["icon-image"].push(i);
            else if (s)
              o !== void 0 ? (e["icon-image"].push(
                // `cluster-icon-${functionName}-${textColor + functionProps.color}-${count}`,
                k(t.clusterIcons[l]),
                o
              ), e["text-size"].push(a, o)) : (e["icon-image"].push(
                // `cluster-icon-${functionName}-${textColor + functionProps.color}-max`
                k(t.clusterIcons[l])
              ), e["text-size"].push(a));
            else
              throw new Error(
                "Icon configuration information is incorrect, no iconName or functionName"
              );
          }
        );
      else {
        const o = t.clusterIcons[0];
        if (o.iconName)
          e["icon-image"] = o.iconName;
        else if (o.functionName)
          e["icon-image"] = k(
            o
          );
        else
          throw new Error(
            "Icon configuration information is incorrect, no iconName or functionName"
          );
        e["text-size"] = o.textSize ? o.textSize : 14;
      }
      return e.visibility = t.show ? "visible" : "none", e;
    }), U = h(() => {
      if (!t.cluster) return;
      const e = {
        "text-color": ["step", ["get", "point_count"]],
        "icon-translate": t.clusterIconTranslate
      };
      return t.clusterIcons.length > 1 ? t.clusterIcons.forEach(({ count: o, textColor: i }) => {
        o !== void 0 ? e["text-color"].push(`${i}`, o) : e["text-color"].push(`${i}`);
      }) : e["text-color"] = t.clusterIcons[0].textColor, e;
    }), K = h(() => Object.assign({}, A.value, {
      "icon-allow-overlap": !0,
      "text-allow-overlap": !0,
      "text-optional": !0
    })), Q = h(() => {
      if (!(!t.cluster || !t.spiderify))
        return {
          "line-color": t.spiderLegColor,
          "line-width": t.spiderLegWidth
        };
    }), k = (e) => {
      const {
        functionName: o,
        textColor: i = "",
        functionProps: s = {},
        count: a
      } = e;
      return e.count !== void 0 ? `cluster-icon-${typeof o == "string" ? o : o.name}-${i + s.color}-${a}` : `cluster-icon-${typeof o == "string" ? o : o.name}-${i + s.color}-max`;
    }, N = () => {
      const e = $();
      t.clusterIcons.length > 0 && t.clusterIcons.forEach(
        ({ iconName: o, functionName: i, functionProps: s }, a) => {
          if (o) return;
          const l = k(t.clusterIcons[a]);
          e.hasImage(l) || (e.addImage(
            l,
            typeof i == "string" ? ae[i](
              e,
              s
            ) : i(e),
            {
              pixelRatio: 2
            }
          ), M.push(l));
        }
      );
    }, X = () => {
      const e = $();
      t.cluster && (M = [], N()), e.on("click", `cluster-${r}`, T), e.on(
        "click",
        `spider-leaf-${r}`,
        w
      ), e.on(
        "mousemove",
        `spider-leaf-${r}`,
        O
      ), e.on(
        "mouseenter",
        `spider-leaf-${r}`,
        z
      ), e.on(
        "mouseleave",
        `spider-leaf-${r}`,
        E
      ), e.on("click", `uncluster-${r}`, w), e.on(
        "mousemove",
        `uncluster-${r}`,
        O
      ), e.on(
        "mouseenter",
        `uncluster-${r}`,
        z
      ), e.on(
        "mouseleave",
        `uncluster-${r}`,
        E
      );
    }, T = (e) => {
      if (!t.pickable || !t.cluster || e.originalEvent.cancelBubble) return;
      const o = $(), i = o.queryRenderedFeatures(e.point, {
        layers: [`cluster-${r}`]
      }), s = i[0].properties.cluster_id, a = o.getSource(r), l = i[0].geometry.coordinates;
      t.spiderify ? a.getClusterLeaves(s, 255, 0, (F, c) => {
        if (F) return;
        let u = !0;
        if (c.length > t.maxLeafesTospiderify)
          u = !1;
        else {
          const [j, f] = c[0].geometry.coordinates, p = 10 ** t.comparePrecision, y = Math.trunc(j * p), g = Math.trunc(f * p);
          for (let x = 1; x < c.length; x++) {
            const { coordinates: d } = c[x].geometry;
            if (y !== Math.trunc(p * d[0]) || g !== Math.trunc(p * d[1])) {
              u = !1;
              break;
            }
          }
        }
        if (u || o.getZoom() >= t.clusterMaxZoom) {
          const j = o.project(l), f = c.slice(), p = [];
          let y;
          c.length > t.clusterSpiralPoints ? y = Y(
            f.length
          ) : y = _(
            f.length
          ), f.forEach((g, x) => {
            const d = o.unproject([
              j.x + y[x].x,
              j.y + y[x].y
            ]);
            g.geometry.coordinates = [
              d.lng,
              d.lat
            ], p.push({
              type: "Feature",
              properties: {},
              geometry: {
                type: "LineString",
                coordinates: [
                  l,
                  [d.lng, d.lat]
                ]
              }
            });
          }), L.data = R.featureCollection(p), C.data = R.featureCollection(
            f
          ), o.once("pitchstart", () => {
            L.data = {
              type: "FeatureCollection",
              features: []
            }, C.data = {
              type: "FeatureCollection",
              features: []
            };
          }), o.once("zoomstart", () => {
            L.data = {
              type: "FeatureCollection",
              features: []
            }, C.data = {
              type: "FeatureCollection",
              features: []
            };
          }), I("clusterclick", {
            pixel: Object.values(e.point),
            mouseCoordinates: e.lngLat.toArray(),
            data: c.map((g) => ({
              coordinates: g.geometry.coordinates,
              properties: g.properties
            })),
            originalEvent: e.originalEvent
          });
        } else
          Z(a, s, l);
      }) : Z(a, s, l), e.originalEvent.cancelBubble = !0;
    }, Z = (e, o, i) => {
      const s = $();
      e.getClusterExpansionZoom(o, (a, l) => {
        a || s.easeTo({
          center: i,
          zoom: l
        });
      });
    }, Y = (e) => {
      const o = {
        rotationsModifier: 1250,
        // Higher modifier = closer spiral lines
        distanceBetweenPoints: t.distanceBetweenSpiderPoints * 0.8,
        // Distance between points in spiral
        radiusModifier: 5e4,
        // Spiral radius
        lengthModifier: 1e3
        // Spiral length modifier
      }, i = [{ x: 0, y: 0 }], s = e * o.rotationsModifier, a = o.distanceBetweenPoints, l = e * o.radiusModifier, F = s * 2 * Math.PI, c = l / F;
      for (let u = a / c; i.length <= e + o.lengthModifier; )
        i.push({
          x: Math.cos(u) * (c * u),
          y: Math.sin(u) * (c * u)
        }), u += a / (c * u);
      return i.slice(0, e);
    }, _ = (e) => {
      const o = [], i = Math.PI * 2 / e;
      for (let s = 0; s < e; s++) {
        const a = i * s;
        o.push({
          x: t.distanceBetweenSpiderPoints * Math.cos(a),
          y: t.distanceBetweenSpiderPoints * Math.sin(a)
        });
      }
      return o;
    }, w = (e) => {
      if (!t.pickable) return;
      const { point: o, features: i } = e;
      I("click", {
        pixel: Object.values(o),
        mouseCoordinates: e.lngLat.toArray(),
        coordinates: i[0].geometry.coordinates,
        properties: i[0].properties,
        originalEvent: e.originalEvent
      });
    }, O = (e) => {
      t.pickable && I("mousemove", {
        pixel: Object.values(e.point),
        mouseCoordinates: e.lngLat.toArray(),
        coordinates: e.features[0].geometry.coordinates,
        properties: e.features[0].properties,
        originalEvent: e.originalEvent
      });
    }, z = (e) => {
      t.pickable && I("mouseenter", {
        pixel: Object.values(e.point),
        mouseCoordinates: e.lngLat.toArray(),
        coordinates: e.features[0].geometry.coordinates,
        properties: e.features[0].properties,
        originalEvent: e.originalEvent
      });
    }, E = (e) => {
      t.pickable && I("mouseleave", e);
    }, G = () => {
      L.data = {
        type: "FeatureCollection",
        features: []
      }, C.data = {
        type: "FeatureCollection",
        features: []
      };
    }, { getMapboxInstance: $ } = pe(X), { sourceIdInternal: r, geoJsonSource: ee, createdHandler: te, exportToGeoJson: oe } = le(t, { geoType: "point" });
    return S(
      () => t.data,
      () => {
        G();
      }
    ), S(
      () => [t.cluster, t.spiderify],
      () => {
        (!t.cluster || !t.spiderify) && G();
      }
    ), S(
      () => [t.cluster, t.clusterIcons],
      () => {
        t.cluster && N();
      },
      {
        deep: !0
      }
    ), ie(() => {
      const e = $();
      e && (M.length && M.forEach((o) => {
        e.removeImage(o);
      }), e.off("click", `cluster-${r}`, T), e.off(
        "click",
        `spider-leaf-${r}`,
        w
      ), e.off(
        "mousemove",
        `spider-leaf-${r}`,
        O
      ), e.off(
        "mouseenter",
        `spider-leaf-${r}`,
        z
      ), e.off(
        "mouseleave",
        `spider-leaf-${r}`,
        E
      ), e.off("click", `uncluster-${r}`, w), e.off(
        "mousemove",
        `uncluster-${r}`,
        O
      ), e.off(
        "mouseenter",
        `uncluster-${r}`,
        z
      ), e.off(
        "mouseleave",
        `uncluster-${r}`,
        E
      ));
    }), V({
      exportToGeoJson: oe
    }), (e, o) => (m(), ne("i", de, [
      e.sourceId ? v("", !0) : (m(), b(n(B), {
        key: 0,
        id: n(r),
        "geo-json-source": n(ee)
      }, null, 8, ["id", "geo-json-source"])),
      e.cluster ? (m(), b(n(P), {
        key: 1,
        id: "cluster-" + n(r),
        type: "symbol",
        "source-layer": e.sourceLayerName,
        "before-id": e.beforeId,
        "source-id": n(r),
        filter: ["has", "point_count"],
        layout: D.value,
        paint: U.value,
        maxzoom: e.clusterMaxZoom + 1,
        minzoom: e.minzoom,
        metadata: { mbLayerId: e.id }
      }, null, 8, ["id", "source-layer", "before-id", "source-id", "layout", "paint", "maxzoom", "minzoom", "metadata"])) : v("", !0),
      se(n(P), {
        id: "uncluster-" + n(r),
        type: "symbol",
        "source-layer": e.sourceLayerName,
        "before-id": e.beforeId,
        "source-id": n(r),
        layout: A.value,
        paint: H.value,
        filter: ["!", ["has", "point_count"]],
        maxzoom: e.maxzoom,
        minzoom: e.minzoom,
        metadata: { mbLayerId: e.id },
        onCreated: n(te)
      }, null, 8, ["id", "source-layer", "before-id", "source-id", "layout", "paint", "maxzoom", "minzoom", "metadata", "onCreated"]),
      e.spiderify && e.cluster ? (m(), b(n(B), {
        key: 2,
        id: "spider-leg-" + n(r),
        "geo-json-source": L
      }, null, 8, ["id", "geo-json-source"])) : v("", !0),
      e.spiderify && e.cluster ? (m(), b(n(P), {
        key: 3,
        id: "spider-leg-" + n(r),
        type: "line",
        "source-id": "spider-leg-" + n(r),
        paint: Q.value,
        metadata: { mbLayerId: e.id }
      }, null, 8, ["id", "source-id", "paint", "metadata"])) : v("", !0),
      e.spiderify && e.cluster ? (m(), b(n(B), {
        key: 4,
        id: "spider-leaf-" + n(r),
        "geo-json-source": C
      }, null, 8, ["id", "geo-json-source"])) : v("", !0),
      e.spiderify && e.cluster ? (m(), b(n(P), {
        key: 5,
        id: "spider-leaf-" + n(r),
        type: "symbol",
        "source-id": "spider-leaf-" + n(r),
        layout: K.value,
        paint: H.value,
        metadata: { mbLayerId: e.id }
      }, null, 8, ["id", "source-id", "layout", "paint", "metadata"])) : v("", !0)
    ]));
  }
});
export {
  Le as default
};
