import o from "axios";
const e = {
  token: "b8ed92ff9b64aebcb0110acca15e478f",
  baseUrl: "//api.tianditu.gov.cn",
  urls: {
    geocoder: "/geocoder",
    search: "/v2/search",
    pathByDrive: "/drive",
    pathByMass: "/transit"
  },
  // 经纬度查地址
  // Latitude and longitude address query
  locationToAddress(t, r, s) {
    return o.get(
      `${e.baseUrl}${e.urls.geocoder}?postStr={'lon':${t},'lat':${r},'ver':1}&type=geocode&tk=${s || e.token}`
    );
  },
  // 地址查经纬度
  // Address latitude and longitude
  addressToLocation(t, r) {
    return o.get(
      `${e.baseUrl}${e.urls.geocoder}?ds={'keyWord':'${t}'}&tk=${r || e.token}`
    );
  },
  // 地名模糊搜索，返回地址列表（包含经纬度）
  // Fuzzy search of place names, returning a list of addresses (including latitude and longitude)
  searchAddressByKeyword(t, r = 10, s = "116.203477,40.013767,116.52208,39.828928", a) {
    return typeof t == "object" ? o.get(
      `${e.baseUrl}${e.urls.search}?postStr=${JSON.stringify(t)}&type=query&tk=${t.token || e.token}`
    ) : o.get(
      `${e.baseUrl}${e.urls.search}?postStr={"keyWord":"${t}","queryType":"7","count":"${r}","start":"0","level":18,"mapBound":"${s}"}&type=query&tk=${a || e.token}`
    );
  },
  // 路径规划 - 自驾
  // Route Planning - Self-driving
  pathGeneratorByCar({
    orig: t,
    dest: r,
    mid: s,
    style: a = 0
  }, n) {
    const $ = `${e.baseUrl}${e.urls.pathByDrive}?postStr={"orig":"${t}","dest":"${r}","mid":"${s}","style":"${a}"}&type=search&tk=${n || e.token}`;
    return o.get($);
  },
  // 路径规划 - 公交
  // Route Planning - Public Transport
  pathGeneratorByMass({
    startPosition: t = "",
    endPosition: r = "",
    lineType: s = "1"
  }, a) {
    const n = `${e.baseUrl}${e.urls.pathByDrive}?type=busline&postStr={'startposition':'${t}','endposition':'${r}',linetype:'${s}'}&tk=${a || e.token}`;
    return o.get(n);
  }
};
export {
  e as TiandituApi
};
