import { v4 as t } from "uuid";
const u = {
  /**
   * 用来访问切片的url,有如下关键字：
   * {z}:切片级别
   * {y}：y轴瓦片号
   * {x}：x轴瓦片号
   * {s}：可用域名
   */
  /**
   * The URL used to access the slice, with the following keywords:
   * {z}: slice level
   * {y}: y-axis tile number
   * {x}: x-axis tile number
   * {s}: available domain name
   */
  url: {
    type: String,
    required: !0
  },
  subdomains: [String, Array],
  /**
   * 数据源切片方案
   * Data source tiling scheme
   * @values 'xyz','tms'
   */
  scheme: {
    type: String,
    default: "xyz",
    validator: (e) => ["xyz", "tms"].includes(e)
  },
  maxzoom: {
    type: Number,
    default: 22
  },
  minzoom: {
    type: Number,
    default: 0
  },
  show: {
    type: Boolean,
    default: !0
  },
  beforeId: {
    type: String
  },
  id: {
    type: String,
    default: () => t()
  },
  extendSource: {
    type: Object,
    default: () => ({})
  }
}, a = {
  created: () => !0
};
export {
  a as urlTemplateLayerEmits,
  u as urlTemplateLayerProps
};
