import type { ExtractPropTypes, PropType } from 'vue';
import type VideoLayer from './video-layer.vue';
export declare const videoLayerProps: {
    urls: {
        type: PropType<string[]>;
        required: boolean;
    };
    /**
     * 图片四个角的经纬度数组，顺序：左上、右上、右下、左下
     * The latitude and longitude array of the four corners of the image, in the following order: top left, top right, bottom right, bottom left
     * eg:[
        [-80.425, 46.437],
        [-71.516, 46.437],
        [-71.516, 37.936],
        [-80.425, 37.936]
    ]
    */
    coordinates: {
        type: PropType<number[][]>;
        required: boolean;
    };
    show: {
        type: BooleanConstructor;
        default: boolean;
    };
    beforeId: StringConstructor;
    id: {
        type: StringConstructor;
        default: () => string;
    };
};
export type VideoLayerProps = ExtractPropTypes<typeof videoLayerProps>;
export declare const videoLayerEmits: {
    created: () => boolean;
};
export type VideoLayerEmits = typeof videoLayerEmits;
export type VideoLayerInstance = InstanceType<typeof VideoLayer>;
