import type { ExtractPropTypes, PropType } from 'vue';
import type WmsLayer from './wms-layer.vue';
export declare const wmsLayerProps: {
    url: {
        type: StringConstructor;
        required: boolean;
    };
    layers: {
        type: StringConstructor;
        required: boolean;
    };
    tileSize: {
        type: NumberConstructor;
        default: number;
    };
    width: {
        type: NumberConstructor;
        default: number;
    };
    height: {
        type: NumberConstructor;
        default: number;
    };
    format: {
        type: StringConstructor;
        default: string;
    };
    subdomains: PropType<string | number[] | string[]>;
    maxzoom: {
        type: NumberConstructor;
        default: number;
    };
    minzoom: {
        type: NumberConstructor;
        default: number;
    };
    show: {
        type: BooleanConstructor;
        default: boolean;
    };
    beforeId: {
        type: StringConstructor;
    };
    version: {
        type: StringConstructor;
        default: string;
    };
    transparent: {
        type: BooleanConstructor;
        default: boolean;
    };
    id: {
        type: StringConstructor;
        default: () => string;
    };
    srs: {
        type: StringConstructor;
        default: string;
    };
    layerStyle: {
        type: StringConstructor;
        default: string;
    };
    extraParams: {
        type: StringConstructor;
        default: string;
    };
};
export type WmsLayerProps = ExtractPropTypes<typeof wmsLayerProps>;
export declare const wmsLayerEmits: {
    created: () => boolean;
};
export type WmsLayerEmits = typeof wmsLayerEmits;
export type WmsLayerInstance = InstanceType<typeof WmsLayer>;
