import type { ExtractPropTypes } from 'vue';
import type BufferCircleLayerV2 from './buffer-circle-layer-v2.vue';
export declare const bufferCircleLayerV2Props: {
    closeOffset: {
        type: import("vue").PropType<number[]>;
        default: number[];
    };
    id: {
        type: StringConstructor;
        default: () => string;
    };
    center: {
        type: import("vue").PropType<number[]>;
        required: boolean;
    };
    radius: {
        type: NumberConstructor;
        default: number;
    };
    borderColor: {
        type: StringConstructor;
        default: string;
    };
    borderOpacity: {
        type: NumberConstructor;
        default: number;
    };
    borderWidth: {
        type: NumberConstructor;
        default: number;
    };
    backgroundColor: {
        type: StringConstructor;
        default: string;
    };
    backgroundOpacity: {
        type: NumberConstructor;
        default: number;
    };
    resizerColor: {
        type: StringConstructor;
        default: string;
    };
    resizerRadius: {
        type: NumberConstructor;
        default: number;
    };
    centerColor: {
        type: StringConstructor;
        default: string;
    };
    centerRadius: {
        type: NumberConstructor;
        default: number;
    };
    closeSize: {
        type: NumberConstructor;
        default: number;
    };
    closable: {
        type: BooleanConstructor;
        default: boolean;
    };
    countable: {
        type: BooleanConstructor;
        default: boolean;
    };
    resizable: {
        type: BooleanConstructor;
        default: boolean;
    };
    draggable: {
        type: BooleanConstructor;
        default: boolean;
    };
    rotatable: {
        type: BooleanConstructor;
        default: boolean;
    };
    rotaterColor: {
        type: StringConstructor;
        default: string;
    };
    visible: {
        type: BooleanConstructor;
        default: boolean;
    };
    textFonts: {
        type: import("vue").PropType<string[]>;
        default: string[];
    };
    textColor: {
        type: StringConstructor;
        default: string;
    };
    textSize: {
        type: NumberConstructor;
        default: number;
    };
    formatter: {
        type: import("vue").PropType<(radiusOrLabel: string | number, arg2?: string | number | undefined, arg3?: string | number | undefined) => string>;
    };
    closeIconUrl: StringConstructor;
    manual: BooleanConstructor;
};
export type BufferCircleLayerV2Props = ExtractPropTypes<typeof bufferCircleLayerV2Props>;
export declare const bufferCircleLayerV2Emits: {
    update: ({ center, radius }: {
        center: number[];
        radius: number;
    }) => boolean;
    close: (event: import("mapbox-gl").MapMouseEvent) => boolean;
    mouseenter: () => boolean;
    mouseleave: () => boolean;
};
export type BufferCircleLayerV2Emits = typeof bufferCircleLayerV2Emits;
export type BufferCircleLayerInstanceV2 = InstanceType<typeof BufferCircleLayerV2>;
