import type { ExtractPropTypes, PropType } from 'vue';
import type BufferCircleLayer from './buffer-circle-layer.vue';
export declare const bufferCircleLayerProps: {
    closeOffset: {
        type: PropType<number[]>;
        default: number[];
    };
    id: {
        type: StringConstructor;
        default: () => string;
    };
    center: {
        type: PropType<number[]>;
        required: boolean;
    };
    radius: {
        type: NumberConstructor;
        default: number;
    };
    borderColor: {
        type: StringConstructor;
        default: string;
    };
    borderOpacity: {
        type: NumberConstructor;
        default: number;
    };
    borderWidth: {
        type: NumberConstructor;
        default: number;
    };
    backgroundColor: {
        type: StringConstructor;
        default: string;
    };
    backgroundOpacity: {
        type: NumberConstructor;
        default: number;
    };
    resizerColor: {
        type: StringConstructor;
        default: string;
    };
    resizerRadius: {
        type: NumberConstructor;
        default: number;
    };
    centerColor: {
        type: StringConstructor;
        default: string;
    };
    centerRadius: {
        type: NumberConstructor;
        default: number;
    };
    closeSize: {
        type: NumberConstructor;
        default: number;
    };
    closable: {
        type: BooleanConstructor;
        default: boolean;
    };
    countable: {
        type: BooleanConstructor;
        default: boolean;
    };
    resizable: {
        type: BooleanConstructor;
        default: boolean;
    };
    draggable: {
        type: BooleanConstructor;
        default: boolean;
    };
    rotatable: {
        type: BooleanConstructor;
        default: boolean;
    };
    rotaterColor: {
        type: StringConstructor;
        default: string;
    };
    visible: {
        type: BooleanConstructor;
        default: boolean;
    };
    textFonts: {
        type: PropType<string[]>;
        default: string[];
    };
    textColor: {
        type: StringConstructor;
        default: string;
    };
    textSize: {
        type: NumberConstructor;
        default: number;
    };
    formatter: {
        type: PropType<(radiusOrLabel: string | number, arg2?: string | number | undefined, arg3?: string | number | undefined) => string>;
    };
    closeIconUrl: StringConstructor;
    manual: BooleanConstructor;
};
export type BufferCircleLayerProps = ExtractPropTypes<typeof bufferCircleLayerProps>;
export declare const bufferCircleLayerEmits: {
    update: ({ center, radius }: {
        center: number[];
        radius: number;
    }) => boolean;
    close: (event: import("mapbox-gl").MapMouseEvent) => boolean;
    mouseenter: () => boolean;
    mouseleave: () => boolean;
};
export type BufferCircleLayerEmits = typeof bufferCircleLayerEmits;
export type BufferCircleLayerInstance = InstanceType<typeof BufferCircleLayer>;
