import type { Units } from '@turf/helpers';
import type { IndexAny } from '@mapbox-vue3/core/es/common';
import type { MapLayerMouseEvent } from 'mapbox-gl';
export type ELLIPSE_CURSOR_KEYS = 'xResizer' | 'yResizer' | 'rotater';
export declare const tuffEllipseOptions: {
    steps: number;
    units: Units;
};
export declare const BUFFER_ELLIPSE_LAYER_ORIGIN: {
    ELLIPSE_BORDER: string;
    ELLIPSE_BACKGROUND: string;
    RESIZER: string;
    ROTATER: string;
    CENTER_POINT: string;
    CLOSE_BUTTON: string;
    DISTANCE_COUNTER: string;
};
export declare const BUFFER_ELLIPSE_SOURCE_ORIGIN = "ellipse-buffer-source";
export declare const createBufferEllipseLayer: () => {
    BUFFER_ELLIPSE_LAYER: IndexAny;
    BUFFER_ELLIPSE_SOURCE: string;
};
export declare const BUFFER_ELLIPSE_RESIZER_OPTIONS: Record<number, IndexAny>;
export declare const getCursorByResizerName: (name: ELLIPSE_CURSOR_KEYS) => string;
export declare const getLayerName: (e: MapLayerMouseEvent) => ELLIPSE_CURSOR_KEYS;
export declare const angleToDegree: (angle: number) => number;
export declare const degreeToAngle: (degree: number) => number;
export declare const square: (x: number) => number;
export declare const getYByXFunc: (xSemiAxis: number, ySemiAxis: number) => (x: number) => number;
