import type { ExtractPropTypes, PropType } from 'vue';
import type BufferPolygonLayer from './buffer-polygon-layer.vue';
export declare const bufferPolygonLayerProps: {
    polygon: {
        type: PropType<number[][]>;
        default: () => never[];
    };
    closeOffset: {
        type: PropType<number[]>;
        default: number[];
    };
    id: {
        type: StringConstructor;
        default: () => string;
    };
    center: {
        type: PropType<number[]>;
        required: boolean;
    };
    radius: {
        type: NumberConstructor;
        default: number;
    };
    borderColor: {
        type: StringConstructor;
        default: string;
    };
    borderOpacity: {
        type: NumberConstructor;
        default: number;
    };
    borderWidth: {
        type: NumberConstructor;
        default: number;
    };
    backgroundColor: {
        type: StringConstructor;
        default: string;
    };
    backgroundOpacity: {
        type: NumberConstructor;
        default: number;
    };
    resizerColor: {
        type: StringConstructor;
        default: string;
    };
    resizerRadius: {
        type: NumberConstructor;
        default: number;
    };
    centerColor: {
        type: StringConstructor;
        default: string;
    };
    centerRadius: {
        type: NumberConstructor;
        default: number;
    };
    closeSize: {
        type: NumberConstructor;
        default: number;
    };
    closable: {
        type: BooleanConstructor;
        default: boolean;
    };
    countable: {
        type: BooleanConstructor;
        default: boolean;
    };
    resizable: {
        type: BooleanConstructor;
        default: boolean;
    };
    draggable: {
        type: BooleanConstructor;
        default: boolean;
    };
    rotatable: {
        type: BooleanConstructor;
        default: boolean;
    };
    rotaterColor: {
        type: StringConstructor;
        default: string;
    };
    visible: {
        type: BooleanConstructor;
        default: boolean;
    };
    textFonts: {
        type: PropType<string[]>;
        default: string[];
    };
    textColor: {
        type: StringConstructor;
        default: string;
    };
    textSize: {
        type: NumberConstructor;
        default: number;
    };
    formatter: {
        type: PropType<(radiusOrLabel: string | number, arg2?: string | number | undefined, arg3?: string | number | undefined) => string>;
    };
    closeIconUrl: StringConstructor;
    manual: BooleanConstructor;
};
export type BufferPolygonLayerProps = ExtractPropTypes<typeof bufferPolygonLayerProps>;
export declare const bufferPolygonLayerEmits: {
    complete: ({ polygon }: {
        polygon: Array<number[]>;
    }) => boolean;
    update: ({ polygon }: {
        polygon: Array<number[]>;
    }) => boolean;
    close: (event: import("mapbox-gl").MapMouseEvent) => boolean;
    mouseenter: () => boolean;
    mouseleave: () => boolean;
};
export type BufferPolygonLayerEmits = typeof bufferPolygonLayerEmits;
export type BufferPolygonLayerInstance = InstanceType<typeof BufferPolygonLayer>;
