import type { Map } from 'mapbox-gl';
declare function drawDynamicGradientCircle(map: Map, opts: Record<string, any>): {
    width: number;
    height: number;
    data: Uint8ClampedArray;
    context: CanvasRenderingContext2D;
    onAdd(): void;
    render(): boolean;
};
declare function drawDynamicCircle(map: Map, opts: Record<string, any>): {
    width: number;
    height: number;
    data: Uint8ClampedArray;
    context: CanvasRenderingContext2D;
    onAdd(): void;
    render(): boolean;
};
declare function drawStaticCircle(map: Map, opts: Record<string, any>): {
    width: number;
    height: number;
    data: Uint8ClampedArray;
    context: CanvasRenderingContext2D;
    onAdd(): void;
    render(): boolean;
};
declare function drawDynamicHeart(map: Map, opts: Record<string, any>): {
    width: number;
    height: number;
    data: Uint8ClampedArray;
    context: CanvasRenderingContext2D;
    onAdd(): void;
    render(): boolean;
};
declare const iconGenerator: {
    drawDynamicCircle: typeof drawDynamicCircle;
    drawStaticCircle: typeof drawStaticCircle;
    drawDynamicGradientCircle: typeof drawDynamicGradientCircle;
    drawDynamicHeart: typeof drawDynamicHeart;
};
export { iconGenerator, drawDynamicCircle, drawStaticCircle, drawDynamicGradientCircle, drawDynamicHeart, };
export type IconGeneratorKey = keyof typeof iconGenerator;
