import type { ExtractPropTypes, PropType } from 'vue';
import type MapMarker from './map-marker.vue';
export declare const mapMarkerProps: {
    /**
     * @values 'center' , 'top' , 'bottom' , 'left' , 'right' , 'top-left' , 'top-right' , 'bottom-left' ,'bottom-right'
     */
    anchor: {
        type: StringConstructor;
        default: string;
    };
    /**
     * 偏移量 正数表示右/上
     * Offset, Positive number means right/top
     */
    offset: {
        type: PropType<number[]>;
        default: () => number[];
    };
    /**
     * 默认标记的颜色 Default marker color
     */
    color: {
        type: StringConstructor;
        default: string;
    };
    draggable: {
        type: BooleanConstructor;
        default: boolean;
    };
    coordinates: {
        type: PropType<number[]>;
        required: boolean;
    };
};
export type MapMarkerProps = ExtractPropTypes<typeof mapMarkerProps>;
export declare const mapMarkerEmits: {
    'update:coordinates': (coordinates: number[]) => boolean;
};
export type MapMarkerEmits = typeof mapMarkerEmits;
export type MapMarkerInstance = InstanceType<typeof MapMarker>;
