import type { AnyLayer, AnySourceData, CameraOptions, EaseToOptions, FlyToOptions, LngLatBoundsLike, LngLatLike } from 'mapbox-gl';
import type { IndexAny } from '@mapbox-vue3/core/es/common';
import type { MapboxInstance } from './map-types';
declare const _default: __VLS_WithTemplateSlots<import("vue").DefineComponent<import("vue").ExtractPropTypes<{
    zoom: {
        type: NumberConstructor;
        default: number;
    };
    center: {
        type: import("vue").PropType<number[]>;
        default: () => number[];
        validator: (value: number[]) => boolean;
    };
    bearing: {
        type: NumberConstructor;
        default: number;
    };
    pitch: {
        type: NumberConstructor;
        default: number;
    };
    bounds: {
        type: import("vue").PropType<any[] | IndexAny>;
        default: undefined;
    };
    maxBounds: {
        type: import("vue").PropType<any[] | IndexAny>;
        default: undefined;
    };
    antialias: {
        type: BooleanConstructor;
        default: boolean;
    };
    minzoom: {
        type: NumberConstructor;
        default: number;
    };
    maxzoom: {
        type: NumberConstructor;
        default: number;
    };
    hash: {
        type: (BooleanConstructor | StringConstructor)[];
        default: boolean;
    };
    interactive: {
        type: BooleanConstructor;
        default: boolean;
    };
    bearingSnap: {
        type: NumberConstructor;
        default: number;
    };
    pitchWithRotate: {
        type: BooleanConstructor;
        default: boolean;
    };
    clickTolerance: {
        type: NumberConstructor;
        default: number;
    };
    attributionControl: {
        type: BooleanConstructor;
        default: boolean;
    };
    mapStyle: {
        type: import("vue").PropType<string | IndexAny>;
        default: () => {
            version: number;
            sources: {};
            layers: never[];
            glyphs: string;
            sprite: string;
        };
    };
    glyphs: {
        type: StringConstructor;
        default: string;
    };
    sprite: {
        type: StringConstructor;
        default: string;
    };
    crs: import("vue").PropType<string | any[]>;
    extendProps: {
        type: import("vue").PropType<IndexAny>;
        default: () => {};
    };
}>, {
    addSource: (id: string, source: AnySourceData) => void;
    getSource: (id: string) => import("mapbox-gl").AnySourceImpl;
    addLayer: (layer: AnyLayer, beforeId?: string | undefined) => void;
    moveLayer: (id: string, beforeId?: string | undefined) => void;
    getZoom: () => number;
    setZoom: (zoomValue: number) => void;
    getCenter: () => [number, number];
    setCenter: (centerValue: number[]) => void;
    resize: () => void;
    reorderLayers: (layerIds: string[]) => void;
    getBearing: () => number;
    setBearing: (bearingValue: number) => void;
    getPitch: () => number;
    setPitch: (pitchValue: number) => void;
    jumpTo: (options: CameraOptions) => void;
    easeTo: (options: EaseToOptions) => Promise<void>;
    flyTo: (options: FlyToOptions) => Promise<void>;
    stop: () => void;
    cameraForBounds: (bounds: LngLatBoundsLike, options: Record<string, any>) => import("mapbox-gl").CameraForBoundsResult | undefined;
    fitBounds: (bounds: LngLatBoundsLike, options: Record<string, any>) => Promise<void>;
    project: (lnglatLike: LngLatLike) => import("mapbox-gl").Point;
}, {}, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {
    created: (map: MapboxInstance) => void;
    click: (args_0: {
        pixel: number[];
        coordinates: number[];
        originalEvent: MouseEvent;
    }) => void;
    dblclick: (args_0: {
        pixel: number[];
        coordinates: number[];
        originalEvent: MouseEvent;
    }) => void;
    mousemove: (args_0: {
        pixel: number[];
        coordinates: number[];
        originalEvent: MouseEvent;
    }) => void;
    mouseout: (event: import("mapbox-gl").MapMouseEvent & import("mapbox-gl").EventData) => void;
    "update:pitch": (pitch: number) => void;
    "update:bearing": (bearing: number) => void;
    "update:center": (center: number[]) => void;
    "update:zoom": (zoom: number) => void;
    singleclick: (args_0: {
        pixel: number[];
        coordinates: number[];
        originalEvent: MouseEvent;
    }) => void;
}, string, import("vue").PublicProps, Readonly<import("vue").ExtractPropTypes<{
    zoom: {
        type: NumberConstructor;
        default: number;
    };
    center: {
        type: import("vue").PropType<number[]>;
        default: () => number[];
        validator: (value: number[]) => boolean;
    };
    bearing: {
        type: NumberConstructor;
        default: number;
    };
    pitch: {
        type: NumberConstructor;
        default: number;
    };
    bounds: {
        type: import("vue").PropType<any[] | IndexAny>;
        default: undefined;
    };
    maxBounds: {
        type: import("vue").PropType<any[] | IndexAny>;
        default: undefined;
    };
    antialias: {
        type: BooleanConstructor;
        default: boolean;
    };
    minzoom: {
        type: NumberConstructor;
        default: number;
    };
    maxzoom: {
        type: NumberConstructor;
        default: number;
    };
    hash: {
        type: (BooleanConstructor | StringConstructor)[];
        default: boolean;
    };
    interactive: {
        type: BooleanConstructor;
        default: boolean;
    };
    bearingSnap: {
        type: NumberConstructor;
        default: number;
    };
    pitchWithRotate: {
        type: BooleanConstructor;
        default: boolean;
    };
    clickTolerance: {
        type: NumberConstructor;
        default: number;
    };
    attributionControl: {
        type: BooleanConstructor;
        default: boolean;
    };
    mapStyle: {
        type: import("vue").PropType<string | IndexAny>;
        default: () => {
            version: number;
            sources: {};
            layers: never[];
            glyphs: string;
            sprite: string;
        };
    };
    glyphs: {
        type: StringConstructor;
        default: string;
    };
    sprite: {
        type: StringConstructor;
        default: string;
    };
    crs: import("vue").PropType<string | any[]>;
    extendProps: {
        type: import("vue").PropType<IndexAny>;
        default: () => {};
    };
}>> & Readonly<{
    onCreated?: ((map: MapboxInstance) => any) | undefined;
    onClick?: ((args_0: {
        pixel: number[];
        coordinates: number[];
        originalEvent: MouseEvent;
    }) => any) | undefined;
    onDblclick?: ((args_0: {
        pixel: number[];
        coordinates: number[];
        originalEvent: MouseEvent;
    }) => any) | undefined;
    onMousemove?: ((args_0: {
        pixel: number[];
        coordinates: number[];
        originalEvent: MouseEvent;
    }) => any) | undefined;
    onMouseout?: ((event: import("mapbox-gl").MapMouseEvent & import("mapbox-gl").EventData) => any) | undefined;
    "onUpdate:pitch"?: ((pitch: number) => any) | undefined;
    "onUpdate:bearing"?: ((bearing: number) => any) | undefined;
    "onUpdate:center"?: ((center: number[]) => any) | undefined;
    "onUpdate:zoom"?: ((zoom: number) => any) | undefined;
    onSingleclick?: ((args_0: {
        pixel: number[];
        coordinates: number[];
        originalEvent: MouseEvent;
    }) => any) | undefined;
}>, {
    zoom: number;
    bearing: number;
    center: number[];
    pitch: number;
    bounds: any[] | IndexAny;
    maxBounds: any[] | IndexAny;
    antialias: boolean;
    minzoom: number;
    maxzoom: number;
    hash: string | boolean;
    interactive: boolean;
    bearingSnap: number;
    pitchWithRotate: boolean;
    clickTolerance: number;
    attributionControl: boolean;
    mapStyle: string | IndexAny;
    glyphs: string;
    sprite: string;
    extendProps: IndexAny;
}, {}, {}, {}, string, import("vue").ComponentProvideOptions, true, {}, any>, {
    default?(_: {}): any;
}>;
export default _default;
type __VLS_WithTemplateSlots<T, S> = T & {
    new (): {
        $slots: S;
    };
};
