import type { ExtractPropTypes, PropType } from 'vue';
import type PolygonLayer from './polygon-layer.vue';
export declare const polygonLayerProps: {
    opacity: {
        type: NumberConstructor;
        default: number;
    };
    /**
     * 颜色值
     * 支持 '#000000' 'rgb(0,0,0)'等模式
     */
    /**
     * Color value
     * Supports modes such as '#000000' 'rgb(0,0,0)'
     */
    color: {
        type: PropType<string | number[]>;
        default: string;
    };
    outlineColor: {
        type: PropType<string | number[]>;
        default: string;
    };
    /**
     * 偏移量，正数表示 右/下
     * Offset, positive number means right/bottom
     */
    translate: {
        type: PropType<number[]>;
        default: () => number[];
    };
    pattern: StringConstructor;
    id: {
        type: StringConstructor;
        default: () => string;
    };
    beforeId: StringConstructor;
    maxzoom: {
        type: NumberConstructor;
        default: number;
    };
    minzoom: {
        type: NumberConstructor;
        default: number;
    };
    show: {
        type: BooleanConstructor;
        default: boolean;
    };
    sourceId: StringConstructor;
    sourceLayerName: StringConstructor;
    geoJsonDataSource: PropType<string | import("mapbox-gl").GeoJSONSource>;
    data: PropType<import("../..").VectorLayerData | import("../..").SymbolLayerData>;
    pickable: {
        type: BooleanConstructor;
        default: boolean;
    };
    useExpression: BooleanConstructor;
    bufferSize: {
        type: NumberConstructor;
        default: number;
    };
    generateId: BooleanConstructor;
    autoHighlight: BooleanConstructor;
    highlightColor: {
        type: PropType<string | number[]>;
        default: () => number[];
    };
    cluster: BooleanConstructor;
    clusterRadius: NumberConstructor;
    clusterMinPoints: NumberConstructor;
    clusterMaxZoom: NumberConstructor;
};
export type PolygonLayerProps = ExtractPropTypes<typeof polygonLayerProps>;
export declare const polygonLayerEmits: {
    created: () => boolean;
    click: ({ pixel, mouseCoordinates, coordinates, properties, originalEvent, }: {
        pixel: number[];
        mouseCoordinates: number[];
        coordinates: number[];
        properties: Record<string, any> | null;
        originalEvent: MouseEvent;
    }) => boolean;
    mousemove: ({ pixel, mouseCoordinates, coordinates, properties, originalEvent, }: {
        pixel: number[];
        mouseCoordinates: number[];
        coordinates: number[];
        properties: Record<string, any> | null;
        originalEvent: MouseEvent;
    }) => boolean;
    mouseleave: (event: import("mapbox-gl").MapMouseEvent) => boolean;
};
export type PolygonLayerEmits = typeof polygonLayerEmits;
export type PolylineLayerInstance = InstanceType<typeof PolygonLayer>;
