import type { ExtractPropTypes, PropType } from 'vue';
import type { IndexAny } from '@mapbox-vue3/core/es/common';
import type { AnySourceImpl } from 'mapbox-gl';
import type Source from './source.vue';
export declare const sourceProps: {
    id: {
        type: StringConstructor;
        default: () => string;
    };
    /**
     * GeoJson source
     * @see {@link https://docs.mapbox.com/mapbox-gl-js/style-spec/sources/#geojson}
     */
    geoJsonSource: {
        type: PropType<IndexAny>;
    };
    /**
     * TileJson Source
     * @see {@link https://www.mapbox.com/mapbox-gl-js/style-spec/#sources}
     */
    tileJsonSource: {
        type: PropType<IndexAny>;
    };
};
export type SourceProps = ExtractPropTypes<typeof sourceProps>;
export declare const sourceEmits: {
    sourceAdded: (source: AnySourceImpl) => boolean;
};
export type SourceEmits = typeof sourceEmits;
export type SourceInstance = InstanceType<typeof Source>;
