import type { ExtractPropTypes, PropType } from 'vue';
import type WmtsLayer from './wmts-layer.vue';
export declare const wmtsLayerProps: {
    url: {
        type: StringConstructor;
        required: boolean;
    };
    format: {
        type: StringConstructor;
        default: string;
    };
    layerName: {
        type: StringConstructor;
        required: boolean;
    };
    layerStyle: {
        type: StringConstructor;
        required: boolean;
    };
    tileMatrixSetID: {
        type: StringConstructor;
        required: boolean;
    };
    tileMatrixPrefix: StringConstructor;
    tileSize: {
        type: NumberConstructor;
        default: number;
    };
    subdomains: PropType<string | number[] | string[]>;
    maxzoom: {
        type: NumberConstructor;
        default: number;
    };
    minzoom: {
        type: NumberConstructor;
        default: number;
    };
    show: {
        type: BooleanConstructor;
        default: boolean;
    };
    id: {
        type: StringConstructor;
        default: () => string;
    };
    beforeId: {
        type: StringConstructor;
    };
    extraParams: {
        type: StringConstructor;
        default: string;
    };
};
export type WmtsLayerProps = ExtractPropTypes<typeof wmtsLayerProps>;
export declare const wmtsLayerEmits: {
    created: () => boolean;
};
export type WmtsLayerEmits = typeof wmtsLayerEmits;
export type WmsLayerInstance = InstanceType<typeof WmtsLayer>;
